<?php
$GLOBALS["AS_ROOT"]=true;
$GLOBALS["RELOAD"]=false;
$GLOBALS["TITLENAME"]="Load-Balancer Daemon";
$GLOBALS["OUTPUT"]=false;
$GLOBALS["COMMANDLINE"]=implode(" ",$argv);
$GLOBALS["NOCONF"]=false;
$GLOBALS["WIZARD"]=false;
$GLOBALS["BY_SCHEDULE"]=false;
$GLOBALS["tproxy_ip"]="127.0.0.1";


if(strpos($GLOBALS["COMMANDLINE"],"--verbose")>0){$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;$GLOBALS["DEBUG"]=true;ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once("/usr/share/artica-postfix/ressources/class.squid.certificates.inc");
include_once("/usr/share/artica-postfix/ressources/class.munin.inc");
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/framework/class.settings.inc");
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;}
if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reload#",implode(" ",$argv))){$GLOBALS["RELOAD"]=true;}
if(preg_match("#--noconf#",implode(" ",$argv))){$GLOBALS["NOCONF"]=true;}
if(preg_match("#--wizard#",implode(" ",$argv))){$GLOBALS["WIZARD"]=true;}
if(preg_match("#--byschedule#",implode(" ",$argv))){$GLOBALS["BY_SCHEDULE"]=true;}
if($argv[1]=="--destroy-log"){destroy_log($argv[2]);}
if($argv[1]=="--build"){build();exit();}
if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
if($argv[1]=="--reload"){$GLOBALS["OUTPUT"]=true;reload();exit();}
if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
if($argv[1]=="--iptables-remove"){iptables_delete_all();exit();}
if($argv[1]=="--install"){install();exit();}
if($argv[1]=="--uninstall"){uninstall();exit();}
if($argv[1]=="--monit"){monit_config();exit();}
if($argv[1]=="--rotate"){rotate();exit();}
if($argv[1]=="--keytab"){keytab($argv[2]);exit;}
if($argv[1]=="--syslog"){syslog_config();}
if($argv[1]=="--start-fw"){start_transparent();}
if($argv[1]=="--stop-fw"){stop_transparent();}

function restart($aspid=false){
    $unix=new unix();

    $Masterbin=$unix->find_program("hacluster");

    if(!is_file($Masterbin)){
        build_progress_restart(110,"{not_installed}");
        if($GLOBALS["OUTPUT"]){echo "ReStarting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, hacluster not installed\n";}
        return false;
    }

    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            build_progress_restart(110,"{already_running}");
            if($GLOBALS["OUTPUT"]){echo "ReStarting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    build_progress_restart(50,"{stopping_service}");
    stop(true);
    build_progress_restart(80,"{building}");
    build();
    syslog_config();
    build_progress_restart(90,"{starting_service}");
    if(!start(true)){
        build_progress_restart(110,"{starting_service} {failed}");
        return false;
    }
    build_progress_restart(100,"{success}");
    return true;
}
function build_progress_restart($pourc,$text){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/hacluster.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/web/hacluster.progress",0755);
}
function build_progress_stop($pourc,$text){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/hacluster-stop.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/web/hacluster-stop.progress.txt",0755);
}
function build_progress_keytab($pourc,$text){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/hacluster.ticket.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/web/hacluster.ticket.progress",0755);
}
function keytab($filename){

    $unix=new unix();
    $keypath="/usr/share/artica-postfix/ressources/conf/upload/$filename";
    if(!is_file($keypath)){
        build_progress_keytab(110,"$filename no such file!");
        return;
    }

    $haClusterAD=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("haClusterAD")));
    $KerberosSecureTicket=intval($haClusterAD["KerberosSecureTicket"]);
    $destinationfile="/home/artica/PowerDNS/Cluster/storage/krb5.keytab";
    $destinationpath=dirname($destinationfile);
    if(!is_file($destinationpath)){@mkdir($destinationpath,0755,true);}
    @chmod($destinationpath,0755);

    if($KerberosSecureTicket==1){
        $openssl=$unix->find_program("openssl");
        $KerberosSecurePass=$unix->GetMyHostId();
        if(is_file($destinationfile)){@unlink($destinationfile);}
        $destinationfile="/home/artica/PowerDNS/Cluster/storage/krb5.crypt";
        echo "Encrypt the krb5.keytab...\n";
        shell_exec("$openssl enc -aes-256-cbc -k $KerberosSecurePass -md sha256 -iter 1000 -in $keypath -out $destinationfile");



    }else {
        if (is_file($destinationfile)) {
            @unlink($destinationfile);
        }
        if (!copy($keypath, $destinationfile)) {
            build_progress_keytab(110, "$filename {failed} copy");
            @unlink($keypath);
            return;
        }

    }
    @unlink($keypath);

    if(!is_file($destinationfile)){
        echo "$destinationfile no such file!\n";
        build_progress_keytab(100,"{failed}");
    }

    $md5=md5_file($destinationfile);
    @file_put_contents("$destinationpath/krb5.md5",$md5);
    build_progress_keytab(100,"{success}");


    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");
    $q->QUERY_SQL("UPDATE hacluster_backends SET status=0");
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    shell_exec("$php /usr/share/artica-postfix/exec.hacluster.connect.php --connect >/dev/null 2>&1 &");
}

function install(){
    $unix=new unix();
    build_progress_restart(20,"{installing}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("Enablehacluster", 1);

    $php=$unix->LOCATE_PHP5_BIN();

    build_progress_restart(30,"{installing}");
    hacluster_install_service();
    monit_config();
    syslog_config();

    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
    build_progress_restart(40,"{installing}");
    echo "[".__LINE__."]:Stopping...\n";
    build_progress_restart(50,"{stopping}");
    stop(true);
    echo "[".__LINE__."]:Starting...\n";
    build_progress_restart(55,"{starting}");
    start(true);
    echo "[".__LINE__."]:Starting OK\n";
    build_progress_restart(60,"{please_wait}...");
    system("$php /usr/share/artica-postfix/exec.syslog-engine.php --rsylogd --restart");
    build_progress_restart(65,"{please_wait}");
    system("$php /usr/share/artica-postfix/exec.ntpdate.php --install");
    build_progress_restart(70,"{please_wait}");
    system("$php /usr/share/artica-postfix/exec.ntpdate.php --reconfigure");
    build_progress_restart(75,"{please_wait}");
    system("$php /usr/share/artica-postfix/exec.logrotate.php --reconfigure");

    build_progress_restart(80,"{please_wait}");
    if(is_file("/etc/init.d/squid")){
        system("$php /usr/share/artica-postfix/exec.squid.disable.php --remove");
    }

    build_progress_restart(85,"{please_wait}");
    if(is_file("/etc/init.d/firehol")){
        shell_exec("$php /usr/share/artica-postfix/exec.firehol.php --disable-progress");
    }

    if(!is_file("/etc/init.d/dnsdist")){
        if(!is_file("/etc/init.d/unbound")){
            build_progress_restart(90,"{please_wait} {installing} {APP_UNBOUND}");
            system("$php /usr/share/artica-postfix/exec.unbound.php --install");
        }
    }



    build_progress_restart(100,"{success}");

}

function syslog_config(){

    $HaClusterRemoteSyslogEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoteSyslogEnabled"));
    $HaClusterRemoteUseTCPPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoteUseTCPPort"));
    $HaClusterRemoteSyslogPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoteSyslogPort"));
    $HaClusterRemoteSyslogAddr=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoteSyslogAddr"));
    if($HaClusterRemoteSyslogPort==0){$HaClusterRemoteSyslogPort=514;}
    $unix=new unix();
    $nohup=$unix->find_program("nohup");

    $h[]="if \$syslogfacility-text == 'local5' and \$syslogseverity-text == 'info' then {";
    $h[]="\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/squid/access.log\")";

    if($HaClusterRemoteSyslogEnabled==1){
        if($HaClusterRemoteSyslogAddr<>null){
            $proto="udp";
            if($HaClusterRemoteUseTCPPort==1){$proto="tcp";}
            $h[]="\taction(type=\"omfwd\" Target=\"$HaClusterRemoteSyslogAddr\" Port=\"$HaClusterRemoteSyslogPort\" Protocol=\"$proto\")";
        }
    }

    $h[]="stop";
    $h[]="}\n";

    $h[]="if  (\$programname =='hacluster') then {";

    $h[]="\tif (\$msg contains \" ft_http TPROXY-BACKEND-HTTP\") then {";
    $h[]="\t\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/hacluster-connections.log\")";
    $h[]="\t\tstop";
    $h[]="\t}";

    $h[]="\tif (\$msg contains \" hacluster proxys\") then {";
    $h[]="\t\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/hacluster-connections.log\")";
    $h[]="\t\tstop";
    $h[]="\t}";

    $h[]="\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/hacluster.log\")";
    $h[]="\tstop";
    $h[]="}";
    @file_put_contents("/etc/rsyslog.d/hacluster.conf",@implode("\n",$h));

    $h=array();
    $h[]="if  (\$programname =='hacluster-client') then {";
    $h[]="\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/hacluster-client.log\")";
    $h[]="\tstop";
    $h[]="}";
    @file_put_contents("/etc/rsyslog.d/hacluster-client.conf",@implode("\n",$h));


    echo "Configuring.....: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Syslog config success\n";

    system("$nohup /etc/init.d/rsyslog restart >/dev/null 2>&1");

}

function destroy_log($logint){
    $unix=new unix();
    $echo= $unix->find_program("echo");


    if($logint==1){
        $size=@filesize("/var/log/squid/access.log");
        $size=$size/1024;
        $size=round($size/1024,2);
        squid_admin_mysql(1,"[Hacluster]: Empty file access.log {$size}MB",__FILE__,__LINE__);
        shell_exec("$echo \" \"> /var/log/squid/access.log");
        shell_exec("/etc/init.d/rsyslog restart");

    }
    if($logint==2){
        $size=@filesize("/var/log/hacluster-connections.log");
        $size=$size/1024;
        $size=round($size/1024,2);
        squid_admin_mysql(1,"[Hacluster]: Empty file hacluster-connections.log {$size}MB",__FILE__,__LINE__);
        shell_exec("$echo \" \"> /var/log/hacluster-connections.log");
        shell_exec("/etc/init.d/rsyslog restart");

    }
    if($logint==3){
        $size=@filesize("/var/log/hacluster-client.log");
        $size=$size/1024;
        $size=round($size/1024,2);
        squid_admin_mysql(1,"[Hacluster]: Empty file hacluster-client.log {$size}MB",__FILE__,__LINE__);
        shell_exec("$echo \" \"> /var/log/hacluster-client.log");
        shell_exec("/etc/init.d/rsyslog restart");

    }


    shell_exec("/etc/init.d/monit reload");

}

function monit_config(){
    $unix=new unix();
    $f=array();
    $nohup=$unix->find_program("nohup");
    $Enablehacluster=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("Enablehacluster"));
    $HaClusterRemoveLogsEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoveLogsEnabled"));
    $HaClusterRemoveLogsSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterRemoveLogsSize"));
    if($HaClusterRemoveLogsSize==0){$HaClusterRemoveLogsSize=500;}
    if($Enablehacluster==0){return false;}

    $tt[]="/var/log/artica-postfix/squid-logger-start.log";
    $tt[]="/var/log/squid/access.log";
    $tt[]="/var/log/hacluster-connections.log";
    $tt[]="/var/log/hacluster-client.log";

    foreach ($tt as $filepath){
        $path=dirname($filepath);
        if(!is_dir($path)){@mkdir($path,0755,true);}
        if(!is_file($filepath)){@touch($filepath);}
    }

    $php=$unix->LOCATE_PHP5_BIN();
    $f[]="check process APP_HAPROXY_CLUSTER";
    $f[]="with pidfile /var/run/hacluster.pid";
    $f[]="start program = \"/etc/init.d/hacluster start --monit\"";
    $f[]="stop program =  \"/etc/init.d/hacluster stop --monit\"";
    $f[]="if 5 restarts within 5 cycles then timeout";
    $f[] = "# HaClusterRemoveLogsEnabled=$HaClusterRemoveLogsEnabled";
    $f[]="";
    if($HaClusterRemoveLogsEnabled==1) {
        $f[] = "check file HaClusterLogs1 with path /var/log/squid/access.log";
        $f[] = "\tif size > {$HaClusterRemoveLogsSize} MB then exec \"/usr/sbin/hacluster-access-log.sh\"";
    }
        $f[] = "";
        $f[]="check file HaClusterLogs2 with path /var/log/hacluster-connections.log";
        $f[]="\tif size > {$HaClusterRemoveLogsSize} MB then exec \"/usr/sbin/hacluster-cnx-log.sh\"";
        $f[] = "";
        $f[]="check file HaClusterLogs3 with path /var/log/hacluster-client.log";
        $f[]="\tif size > {$HaClusterRemoveLogsSize} MB then exec \"/usr/sbin/hacluster-client-log.sh\"";
    $f[] = "";


        $SCRIPT=array();
        $SCRIPT[]="#!/bin/sh";
        $SCRIPT[]="";
        $SCRIPT[]="$nohup $php /usr/share/artica-postfix/exec.hacluster.php --destroy-log 1 >/dev/null 2>&1 &";
        $SCRIPT[]="return 0\n";
        @file_put_contents("/usr/sbin/hacluster-access-log.sh", @implode("\n", $SCRIPT));
        @chmod("/usr/sbin/hacluster-access-log.sh", 0755);

        $SCRIPT=array();
        $SCRIPT[]="#!/bin/sh";
        $SCRIPT[]="";
        $SCRIPT[]="$nohup $php /usr/share/artica-postfix/exec.hacluster.php --destroy-log 2 >/dev/null 2>&1 &";
        $SCRIPT[]="return 0\n";
        @file_put_contents("/usr/sbin/hacluster-cnx-log.sh", @implode("\n", $SCRIPT));
        @chmod("/usr/sbin/hacluster-cnx-log.sh", 0755);

        $SCRIPT=array();
        $SCRIPT[]="#!/bin/sh";
        $SCRIPT[]="";
        $SCRIPT[]="$nohup $php /usr/share/artica-postfix/exec.hacluster.php --destroy-log 3 >/dev/null 2>&1 &";
        $SCRIPT[]="return 0\n";

        @file_put_contents("/usr/sbin/hacluster-client-log.sh", @implode("\n", $SCRIPT));
        @chmod("/usr/sbin/hacluster-client-log.sh", 0755);

        $SCRIPT=array();
        $SCRIPT[]="#!/bin/sh";
        $SCRIPT[]="";
        $SCRIPT[]="# $php /usr/share/artica-postfix/exec.hacluster.php --rotate";
        $SCRIPT[]="";
        @file_put_contents("/usr/sbin/hacluster-rotate.sh", @implode("\n", $SCRIPT));
        @chmod("/usr/sbin/hacluster-rotate.sh", 0755);


        @file_put_contents("/etc/monit/conf.d/APP_HAPROXY_CLUSTER.monitrc", @implode("\n", $f));

    if($GLOBALS["RELOAD"]){
        shell_exec("/etc/init.d/monit restart");
    }
    return true;
}


function start_transparent_uninstall_service(){

    if(is_file("/etc/init.d/hacluster-transparent")) {
        remove_service("/etc/init.d/hacluster-transparent");
    }

    if(is_file("/etc/monit/conf.d/APP_HAPROXY_CLUSTER_TRANSPARENT.monitrc")){
        @unlink("/etc/monit/conf.d/APP_HAPROXY_CLUSTER_TRANSPARENT.monitrc");
        shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
    }

}

function uninstall(){
    build_progress_restart(20,"{uninstalling}");
    squid_admin_mysql(0,"HaCluster is uninstalled!",null,__FILE__,__LINE__);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("Enablehacluster", 0);
    remove_service("/etc/init.d/hacluster");
    remove_service("/etc/init.d/hacluster-tail");
    @unlink("/etc/cron.d/hacluster-monthly");
    @unlink("/etc/cron.d/hacluster-yearly");
    @unlink("/etc/monit/conf.d/APP_HAPROXY_CLUSTER.monitrc");
    @unlink("/etc/monit/conf.d/APP_HAPROXY_CLUSTER_TAIL.monitrc");
    @unlink("/etc/cron.d/hacluster-rotate");
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
    shell_exec("/etc/init.d/cron reload");

    if(is_file("/etc/rsyslog.d/hacluster.conf")){
        @unlink("/etc/rsyslog.d/hacluster.conf");
        @unlink("/etc/rsyslog.d/hacluster-client.conf");
        system("/etc/init.d/rsyslog restart");
    }
    if(is_file("/etc/rsyslog.d/hacluster-client.conf")){
        @unlink("/etc/rsyslog.d/hacluster-client.conf");
        system("/etc/init.d/rsyslog restart");
    }
    if(is_file("/etc/init.d/hacluster-transparent")) {
        start_transparent_uninstall_service();
    }



    $munin=new munin_plugins();
    $munin->build();


    build_progress_restart(100,"{success}");
}

function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

    }

    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}


function start_transparent_install_monit(){

    if(is_file("/etc/monit/conf.d/APP_HAPROXY_CLUSTER_TRANSPARENT.monitrc")){return;}
    $f[]="check process APP_HAPROXY_CLUSTER_TRANSPARENT";
    $f[]="with pidfile /var/run/hacluster/squid.pid";
    $f[]="start program = \"/etc/init.d/hacluster-transparent start --monit\"";
    $f[]="stop program =  \"/etc/init.d/hacluster-transparent stop --monit\"";
    $f[]="if 5 restarts within 5 cycles then timeout";
    @file_put_contents("/etc/monit/conf.d/APP_HAPROXY_CLUSTER_TRANSPARENT.monitrc",@implode("\n",$f));
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");


}


function start_transparent_install_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/hacluster-transparent";
    $php5script="exec.hacluster.php";
    $daemonbinLog="Load-Balancer Daemon transparent method";



    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:         artica-hacluster-transparent";
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";

    $f[]="case \"\$1\" in";
    $f[]=" start)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start-fw \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop-fw \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop-fw \$2 \$3";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start-fw \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reload)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start-fw \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start-fw \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }

    start_transparent_install_monit();

    $EnableipV6=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));


    if($EnableipV6==0){
        echo "Activate ipv6 configuration...\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableipV6",1);
        shell_exec("$php /usr/share/artica-postfix/exec.sysctl.php --build");
        shell_exec("$php /usr/share/artica-postfix/exec.sysctl.php --start");
    }

}

function hacluster_install_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/hacluster";
    $php5script="exec.hacluster.php";
    $daemonbinLog="Load-Balancer Daemon";



    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:         artica-hacluster";
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";

    $f[]="case \"\$1\" in";
    $f[]=" start)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reload)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }

}

function hacluster_tail_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/hacluster-tail";
    $php5script="exec.hacluster-tail-init.php";
    $daemonbinLog="Load-Balancer tail Daemon";



    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:         hacluster-tail";
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";

    $f[]="case \"\$1\" in";
    $f[]=" start)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reload)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }


}
function reload(){
    if(!$GLOBALS["NOCONF"]){
        build_progress_restart(20,"{building_settings}");
        build();
        syslog_config();
    }
    if(!isRunning()){
        build_progress_restart(50,"{starting_service}");
        start(true);
        if(!isRunning()){build_progress_restart(110,"{starting_service} {failed}");return;}
        build_progress_restart(100,"{starting_service} {success}");
        syslog_config();
        return;
    }
    $unix=new unix();
    $hacluster=$unix->find_program("hacluster");
    $CONFIG="/etc/hacluster/hacluster.cfg";
    $PIDFILE="/var/run/hacluster.pid";
    $EXTRAOPTS=null;
    $pids=@implode(" ", pidsarr());
    build_progress_restart(90,"{reloading} $pids");

    $cmd="$hacluster -f \"$CONFIG\" -p $PIDFILE -D $EXTRAOPTS -sf $pids 2>&1";
    exec($cmd,$results);
    foreach ($results as $num=>$ligne){
        echo "Starting......: ".date("H:i:s")." {$GLOBALS["TITLENAME"]} $ligne\n";
    }
    build_progress_restart(100,"{reloading} {success}");
}

function isRunning(){
    $unix=new unix();
    $f=pidsarr();
    foreach ($f as $pid){
        if($unix->process_exists($pid)){
            return true;
        }
    }

    return false;
}

function pidsarr(){
    $R=array();
    $f=file("/var/run/hacluster.pid");
    foreach ($f as $ligne){
        $ligne=trim($ligne);
        if(!is_numeric($ligne)){continue;}
        $R[]=$ligne;
    }
    return $R;
}


function start_transparent_squid_config(){

    $unix=new unix();
    $hostname=$unix->hostname_g();

    $php=$unix->LOCATE_PHP5_BIN();
    $chown=$unix->find_program("chown");
    $MKDIRS[]="/etc/squid3";
    $MKDIRS[]="/usr/share/squid3/icons";
    $MKDIRS[]="/var/log/hacluster";
    $MKDIRS[]="/var/cache/squid";
    $MKDIRS[]="/var/run/squid";


    foreach ($MKDIRS as $directory){
        if(!is_dir($directory)){@mkdir($directory,0755,true);}
        @chown($directory,"squid");
        @chgrp($directory,"squid");
    }

    if(!is_file("/etc/squid3/mime.conf")) {
        if (is_file("/etc/squid3/mime.conf.default")) {
            @copy("/etc/squid3/mime.conf.default", "/etc/squid3/mime.conf");
        }
    }
    if(!is_file("/etc/squid3/mime.conf")) {
        shell_exec("$php /usr/share/artica-postfix/exec.squid.php --mime --force-mime");
    }
    $HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));
    $HaClusterTransParentDebug=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentDebug"));
    $HaClusterTransParentCertif=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentCertif"));
    $HaClusterTransparentBalance=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransparentBalance"));
    $CPU_NUMBER=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CPU_NUMBER"));
    if($CPU_NUMBER==0){$CPU_NUMBER=intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("services.php?CPU-NUMBER=yes"));}
    if($HaClusterTransparentBalance==null){$HaClusterTransparentBalance="leastconn";}
    $squid_certificate=new squid_certificate();

    if(intval($HaClusterGBConfig["HaClusterDecryptSSL"])==1){
        $HaClusterTransParentCertif=$HaClusterGBConfig["HaClusterCertif"];
    }


    $ssl_crtd = $unix->squid_locate_generic_bin("security_file_certgen");



    if(!is_dir("/var/cache/squid/ssl_db")){
        system("$ssl_crtd  -c -s /var/cache/squid/ssl_db -M 4MB");

    }
    system("$chown -R squid:squid /var/cache/squid");

    $ssl_line=$squid_certificate->BuildSquidCertificate($HaClusterTransParentCertif);
    $ssl_bump_line="ssl-bump $ssl_line";

    $HaClusterTransParentCPU=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentCPU"));

    $f[]="pid_filename /var/run/hacluster/squid.pid";
    $f[]="debug_options ALL,1";
    $f[]="visible_hostname Tproxy-$hostname";

    $f[]="http_port 127.0.0.1:3150";
    $f[]="http_port {$GLOBALS["tproxy_ip"]}:3154 tproxy";
    $f[]="https_port {$GLOBALS["tproxy_ip"]}:3155 tproxy $ssl_bump_line";
    $f[]="pinger_enable off";
    $f[]="http_access allow all";

    $algo["source"]=" sourcehash";
    $algo["roundrobin"]=" round-robin";
    $algo["leastconn"]=null;

    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");

    if(!$q->FIELD_EXISTS("hacluster_backends","isDisconnected")){ $q->QUERY_SQL("ALTER TABLE  hacluster_backends ADD isDisconnected INTEGER NOT NULL DEFAULT 0"); }

    $sql="SELECT *  FROM `hacluster_backends`  WHERE enabled=1 AND status=100 AND isDisconnected=0 ORDER BY bweight";
    $results = $q->QUERY_SQL($sql);
    foreach ($results as $index=>$ligne) {
        $ID=$ligne["ID"];
        $listen_ip=$ligne["listen_ip"];
        $bweight=intval($ligne["bweight"]);
        if($bweight==0){$bweight=1;}
        $balance=$algo[$HaClusterTransparentBalance];
        $f[]="cache_peer $listen_ip parent 47887  0  proxy-only no-delay{$balance} no-query no-tproxy name=T-{$ID}";
    }
//



    $f[]="never_direct allow all";
    $f[]="forwarded_for on";
    $f[]="retry_on_error on";
    $f[]="sslcrtd_program /usr/lib/squid3/security_file_certgen -s /var/cache/squid/ssl_db  -M 8MB";
    $f[]="sslcrtd_children 32 startup=5 idle=1 queue-size=64";
    $f[]="acl ssl_step1 at_step SslBump1";
    $f[]="acl ssl_step2 at_step SslBump2";
    $f[]="acl ssl_step3 at_step SslBump3";
    $f[]="ssl_bump peek ssl_step1";
    $f[]="ssl_bump splice all";
    if($CPU_NUMBER>2) {
        if ($HaClusterTransParentCPU > 1) {
            $f[] = "workers $HaClusterTransParentCPU";
        }
        $Cores=1;
        for($i=1;$i<$HaClusterTransParentCPU+1;$i++){
            $Cores++;
            $process_numbers[]=$i;
            $cores[]=$Cores;

        }

        $f[]="cpu_affinity_map process_numbers=".@implode(",",$process_numbers)." cores=".@implode(",",$cores);

    }

    if($HaClusterTransParentDebug==1){
        $f[]="access_log stdio:/var/log/hacluster/access.log";
        $f[]="cache_log /var/log/hacluster/cache.log";
        $f[]="debug_options ALL,1";
    }else{
        $f[]="cache_log /dev/null";
        $f[]="access_log none all";
        $f[]="debug_options ALL,0";
    }


    $f[]="cache_mem 1024 MB";
    $f[]="maximum_object_size_in_memory 1 MB";
    $f[]="memory_cache_mode network";
    $f[]="max_filedescriptors 65535";
    @file_put_contents("/etc/hacluster/tproxy.conf",@implode("\n",$f));
    shell_exec("ulimit -n 65535");
    echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/hacluster/tproxy.conf success\n";
}

function build(){
    //https://docs.diladele.com/administrator_guide_stable/active_directory_extra/redundancy/haproxy_proxy_protocol.html
    $unix=new unix();
    if(!$unix->SystemUserExists("squid")){
        $unix->SystemCreateUser("squid","squid");
    }
    $dirs[]     = "/etc/hacluster";
    $dirs[]     = "/var/run/hacluster";
    $dirs[]     = "/var/lib/hacluster";
    $ListenIP   = null;
    $php        = $unix->LOCATE_PHP5_BIN();

    $HaClusterInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterInterface"));
    $HaClusterPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterPort"));
    $EnableZabbixAgent=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableZabbixAgent"));
    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");

    if(is_file("/etc/init.d/firehol")){
        shell_exec("$php /usr/share/artica-postfix/exec.firehol.php --disable-progress");
    }

    if(!is_file("/etc/cron.d/hacluster-syslog")){
        $f[]="PATH=PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/X11R6/bin:/usr/share/artica-postfix/bin";
        $f[]="MAILTO=\"\"";
        $f[]="50 4 * * *      root    /etc/init.d/rsyslog restart >/dev/null 2>&1";
        $f[]="";
        @file_put_contents("/etc/cron.d/hacluster-syslog",@implode("\n",$f));
        shell_exec("/etc/init.d/cron reload");
        $f=array();
    }


    if($HaClusterPort==0){$HaClusterPort=3128;}

    if($HaClusterInterface<>null){
        $ListenIP=$unix->InterfaceToIP($HaClusterInterface);
    }

    $bind=":$HaClusterPort";
    if($ListenIP<>null){$bind="$ListenIP$HaClusterPort";}
    $HaClusterBalance=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterBalance");
    if($HaClusterBalance==null){$HaClusterBalance="leastconn";}

    foreach ($dirs as $directory){
        if(!is_dir($directory)) {
            @mkdir($directory, 0755, true);
        }
        @chmod($directory,0755);
        @chown($directory,"squid");
        @chgrp($directory,"squid");
    }

    if(is_file("/etc/init.d/squid")){
        system("$php /usr/share/artica-postfix/exec.squid.disable.php --remove");
    }

    $HaClusterProto=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterProto");
    if($HaClusterProto==null){$HaClusterProto="tcp";}

    $HaClusterWorkers=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterWorkers"));
    $HaClusterMaxConn=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterMaxConn"));
    if($HaClusterMaxConn<2000){$HaClusterMaxConn=2000;}
    if($HaClusterWorkers==0){$HaClusterWorkers=1;}

    $f[]="global";
    $f[]="    log               127.0.0.1 local0 info";
    $f[]="    stats socket      /run/hacluster/admin.sock mode 660 level admin";
    $f[]="    stats timeout     30s";
    $f[]="    user              root";
    $f[]="    group             root";
    $f[]="    daemon";
    $f[]="    maxconn           $HaClusterMaxConn";

    if($HaClusterWorkers>1){
        $f[]="    nbproc           $HaClusterWorkers";
        for($i=1;$i<$HaClusterWorkers+1;$i++){
            $cpumap=$i-1;
            $f[]="    cpu-map           $i $cpumap";
        }
    }


    $f[]="";
    $f[]="defaults";
    $f[]="    log     global";
    $f[]="    mode    tcp";
    $f[]="    option  tcplog";
    $f[]="    option  dontlognull";
    $f[]="    timeout connect 5000";
    $f[]="    timeout client  50000";
    $f[]="    timeout server  50000";
    $f[]="";


    $f[] = "frontend hacluster";
    $f[] = "\tbind\t$bind";
    $f[] = "\tmode $HaClusterProto";
    if($HaClusterProto=="http"){
        $f[] = "\toption forwardfor";
        $f[] = "\toption http-server-close";
    }
    $f[] ="\tdefault_backend proxys";
    $f[]="";
    $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));

    if($HaClusterTransParentMode==1){

        $HaClusterTransparentBalance=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransparentBalance"));
        if($HaClusterTransparentBalance==null){$HaClusterTransparentBalance="leastconn";}

    }




    $f[]="backend proxys";
    $f[]="\tbalance $HaClusterBalance";
    if($HaClusterBalance=="source"){
        $f[]="\thash-type consistent";
        $f[]="\tstick-table type ip size 1m expire 1h";
        $f[]="\tstick on src";
    }
    $f[] = "\tlog-tag rt-requests";
    $f[] = "\tmode $HaClusterProto";


    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");
    if(!$q->FIELD_EXISTS("hacluster_backends","isDisconnected")){ $q->QUERY_SQL("ALTER TABLE  hacluster_backends ADD isDisconnected INTEGER NOT NULL DEFAULT 0"); }
    $sql="SELECT *  FROM `hacluster_backends`  WHERE enabled=1 AND status=100 AND isDisconnected=0 ORDER BY bweight";
    $results = $q->QUERY_SQL($sql);

    foreach ($results as $index=>$ligne) {
        $ID=$ligne["ID"];
        $listen_port=$ligne["listen_port"];
        $listen_ip=$ligne["listen_ip"];
        $bweight=intval($ligne["bweight"]);
        if($bweight==0){$bweight=1;}
        //$f[]="#    hostname:{$ligne["hostname"]} ip={$ligne["listen_ip"]} id=$ID";
        $f[]="\tserver proxy{$ID} {$listen_ip}:{$listen_port} send-proxy weight $bweight check";

    }

    $f[] = "";
    $f[] = "";
    if($EnableZabbixAgent==1) {
        $f[] = "";
        $f[] = "frontend stats";
        $f[]="      mode            http";
        $f[] = "    bind            127.0.0.1:44787";
        $f[] = "    stats           enable";
        $f[] = "    stats uri       /stats";
        $f[] = "    stats refresh   10s";
        $f[] = "    stats admin     if TRUE";

    }
    $f[] = "";
    $f[] = "";
    @file_put_contents("/etc/hacluster/hacluster.cfg", @implode("\n",$f));
    zabbix_proxy_config();
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, /etc/hacluster/hacluster.cfg done\n";



}

function zabbix_proxy_config(){

    $EnableZabbixAgent=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableZabbixAgent"));
    if($EnableZabbixAgent==0){return false;}
    $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));

    $Zabbix_file="/etc/zabbix/zabbix_agentd.d/HaCluster_transparent.conf";
    if($HaClusterTransParentMode==0){
        if(!is_file($Zabbix_file)){return false;}
        @unlink($Zabbix_file);
        shell_exec("/etc/init.d/zabbix-agent restart");
        return true;
    }

    if(!is_file($Zabbix_file)) {

        $f[] = "#HaCluster TRansaprent 3.4 template";
        $f[] = "";
        $f[] = "# Cache information for squid:";
        $f[] = "UserParameter=HaClusterTransparent.disk_hits_as_of_hit_requests,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Disk hits as % of hit requests:'|cut -d':' -f3|cut -d',' -f1|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.hits_as_of_all_requests,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Hits as % of all requests:'|cut -d':' -f3|cut -d',' -f1|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.hits_as_of_bytes_sent,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Hits as % of bytes sent:'|cut -d':' -f3|cut -d',' -f1|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.mean_object_size,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Mean Object Size:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.memory_hits_as_of_hit_requests,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Memory hits as % of hit requests:'|cut -d':' -f3|cut -d',' -f1|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.storage_mem_capacity,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Storage Mem capacity:'|cut -d':' -f2|awk '{print $1}'|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.storage_mem_size,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Storage Mem size:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.storage_swap_capacity,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Storage Swap capacity:'|cut -d':' -f2|awk '{print $1}'|tr -d ' %'";
        $f[] = "UserParameter=HaClusterTransparent.storage_swap_size,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Storage Swap size:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "";
        $f[] = "# Connection information for squid";
        $f[] = "UserParameter=HaClusterTransparent.average_http_requests_per_minute_since_start,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Average HTTP requests per minute since start:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.average_icp_messages_per_minute_since_start,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Average ICP messages per minute since start:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_clients_accessing_cache,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of clients accessing cache:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_htcp_messages_received,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of HTCP messages received:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_htcp_messages_sent,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of HTCP messages sent:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_http_requests_received,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of HTTP requests received:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_icp_messages_received,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of ICP messages received:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_icp_messages_sent,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of ICP messages sent:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_queued_icp_replies,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of queued ICP replies:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.request_failure_ratio,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Request failure ratio:'|cut -d':' -f2| tr -d ' \\t'";
        $f[] = "";
        $f[] = "# File descriptor usage for squid";
        $f[] = "UserParameter=HaClusterTransparent.available_number_of_file_descriptors,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Available number of file descriptors:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.files_queued_for_open,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Files queued for open:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.largest_file_desc_currently_in_use,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Largest file desc currently in use:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.maximum_number_of_file_descriptors,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Maximum number of file descriptors:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.number_of_file_desc_currently_in_use,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Number of file desc currently in use:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.reserved_number_of_file_descriptors,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Reserved number of file descriptors:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.store_disk_files_open,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Store Disk files open:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "";
        $f[] = "# Median Service Times (seconds)";
        $f[] = "UserParameter=HaClusterTransparent.cache_hits,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Cache Hits:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.cache_misses,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Cache Misses:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.dns_lookups,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'DNS Lookups:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.http_requests_all,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'HTTP Requests (All):'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.icp_queries,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'ICP Queries:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.near_hits,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Near Hits:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "UserParameter=HaClusterTransparent.not_modified_replies,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Not-Modified Replies:'|cut -d':' -f2|tr -s ' '|awk '{print $1}'";
        $f[] = "";
        $f[] = "# Resource usage for squid";
        $f[] = "UserParameter=HaClusterTransparent.cpu_usage,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'CPU Usage:'|cut -d':' -f2|tr -d '%'|tr -d ' \\t'";
        $f[] = "UserParameter=HaClusterTransparent.maximum_resident_size,/usr/bin/squidclient -h 127.0.0.1 -p 3150 mgr:info 2>&1|grep 'Maximum Resident Size:'|cut -d':' -f2|awk '{print $1}'";
        $f[] = "";
        @file_put_contents($Zabbix_file, @implode("\n", $f));
        shell_exec("/etc/init.d/zabbix-agent restart");
    }

    return true;

}

function UDPServerRun(){
    $f=explode("\n",@file_get_contents("/etc/rsyslog.conf"));

    foreach ($f as $num=>$ligne){
        $ligne=trim($ligne);
        if(substr($ligne, 0,1)=="#"){continue;}
        if(!preg_match("#UDPServerRun#", $ligne)){continue;}
        return true;

    }
    return false;
}

function start($aspid=false){
    $unix=new unix();

    $Masterbin=$unix->find_program("haproxy");

    if(!is_file($Masterbin)){
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, haproxy not installed\n";
        build_progress_stop(110,"{failed}");
        return false;}

    $nextbin=dirname($Masterbin)."/hacluster";

    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, $Masterbin -> $nextbin\n";




    if(is_file($nextbin)) {
        @unlink($nextbin);
    }
    @copy($Masterbin, $nextbin);
    @chmod($nextbin, 0755);



    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
            build_progress_stop(110,"{failed}");
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();

    if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
        start_transparent();
        build_progress_stop(100,"{success}");
        return true;
    }
    $Enablehacluster=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("Enablehacluster"));
    build();
    if(!is_file("/etc/hacluster/hacluster.cfg")){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/hacluster/hacluster.cfg no such file\n";}
        build_progress_stop(110,"{failed}");
        return false;
    }

    if($Enablehacluster==0){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service disabled (see Enablehacluster)\n";}
        build_progress_stop(110,"{failed} {disabled}");
        return false;
    }

    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");


    if(!UDPServerRun()){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} syslog server is not ready, prepare it\n";}
        system("$php5 /usr/share/artica-postfix/exec.syslog-engine.php --buildconf");
        if(UDPServerRun()){
            system("/etc/init.d/rsyslog restart");
        }else{
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed to prepare syslog engine\n";}
        }
    }else{
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} syslog server [OK]\n";}
    }

    build();


    build_progress_stop(50,"{starting}");
    $cmd="$nohup $nextbin -f /etc/hacluster/hacluster.cfg -D -p /var/run/hacluster.pid  >/dev/null 2>&1 &";

    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service\n";}

    shell_exec($cmd);



    $prc=50;
    for($i=1;$i<5;$i++){
        build_progress_restart(95,"{starting_service} $i/5");
        build_progress_stop($prc++,"{starting_service} $i/5");
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";}
        sleep(1);
        $pid=PID_NUM();
        if($unix->process_exists($pid)){break;}
    }

    $pid=PID_NUM();
    if($unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";}
        build_progress_stop(100,"{starting_service} {success}");
        return start_transparent();
    }else{
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";}
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";}
        build_progress_stop(110,"{starting_service} {failed}");
        return false;
    }

}
function PID_NUM(){

    $unix=new unix();
    $pid=$unix->get_pid_from_file("/var/run/hacluster.pid");
    if( $unix->process_exists($pid) ){ return $pid; }
    $Masterbin=$unix->find_program("hacluster");
    return $unix->PIDOF($Masterbin);
}

function stop_transparent_check_stopped($filetmp){

    $f=explode("\n",@file_get_contents($filetmp));

    foreach ($f as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#WARNING: #",$line)){continue;}
        if(preg_match("#FATAL: failed to send signal [0-9] to Squid instance#i",$line)){
            @unlink($filetmp);
            return true;
        }
        if(preg_match("#FATAL: failed to open .*?\.pid#i",$line)){
            @unlink($filetmp);
            return true;
        }
        echo $line."\n";
    }
    @unlink($filetmp);
}

function stop_transparent_check_childs(){

    $unix=new unix();
    $pgrep=$unix->find_program("pgrep");
    exec("$pgrep -lf \"kid squid-[0-9]+ -f \/etc\/hacluster\/\" 2>&1",$results);
    $array=array();
    foreach ($results as $line){
        if(preg_match("#^[0-9]+\s+.*?pgrep#",$line)){continue;}
        if(!preg_match("#^([0-9]+)\s+#",$line,$re)){continue;}
        $array[]=$re[1];

    }

    return $array;
}


function stop($aspid=false){
    $unix=new unix();
    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";}
            build_progress_stop(110,"{failed}");
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();


    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
        build_progress_stop(100,"{success}");
        return stop_transparent();
    }
    $pid=PID_NUM();

    build_progress_stop(50,"{stopping_service} pid:$pid");
    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
    unix_system_kill($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    $pid=PID_NUM();
    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
        build_progress_stop(100,"{stopping_service} {success}");
        return stop_transparent();
    }

    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
    unix_system_kill_force($pid);
    build_progress_stop(60,"{stopping_service} pid:$pid");
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    if($unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
        build_progress_stop(110,"{stopping_service} pid:$pid {failed}");
        return false;
    }
    build_progress_stop(100,"{stopping_service} {success}");

    return stop_transparent();

}

function sources_white(){
    $unix=new unix();
    $sources=array();
    $iptables_save=$unix->find_program("iptables-save");
    exec("$iptables_save 2>&1",$results);
    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#-A PREROUTING -s (.+?)\/32.*?-j RETURN#",$line,$re)){
            if(preg_match("#^-A\s+(.+)#",$line,$re)){
                $sources[]=$re[1];
            }

        }


    }
    return $sources;

}

function stop_transparent(){
    $unix=new unix();
    $ip=$unix->find_program("ip");
    $iptables=$unix->find_program("iptables");

    $DETECTED=if_iptables_divert();
    echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $DETECTED Firewall Rules\n";
    while($DETECTED>0){
        echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Remove Firewall Rules\n";
        shell_exec("$iptables -t mangle -D PREROUTING -p tcp -m socket -m comment --comment HaCluster -j DIVERT >/dev/null 2>&1");
        shell_exec("$iptables -t mangle -D PREROUTING -p tcp -m tcp --dport 80 -m comment --comment HaCluster -j TPROXY --on-port 3154 --on-ip 127.0.0.1 --tproxy-mark 0x6f/0xffffffff");
        shell_exec("$iptables -t mangle -D PREROUTING -p tcp -m tcp --dport 443 -m comment --comment HaCluster -j TPROXY --on-port 3155 --on-ip 127.0.0.1 --tproxy-mark 0x6f/0xffffffff");
        shell_exec("$iptables -t mangle -D DIVERT -m comment --comment HaCluster -j MARK --set-xmark 111 >/dev/null 2>&1");
        shell_exec("$iptables -t mangle -D DIVERT -m comment --comment HaCluster -j ACCEPT >/dev/null 2>&1");
        shell_exec("$iptables -t nat -D POSTROUTING -j MASQUERADE -m comment --comment HaCluster >/dev/null 2>&1");

        $DETECTED=if_iptables_divert();
        echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $DETECTED Firewall Rules\n";


    }

    $sources_white=sources_white();
    if(count($sources_white)>0){

        foreach ($sources_white as $ipaddr){
            echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} removing $ipaddr\n";
            shell_exec("$iptables -t mangle -D $ipaddr");
            
        }
    }



    if(if_ip_rule()){

        while(if_ip_rule()==true) {
            echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Remove IP rule MARK 111\n";
            shell_exec("$ip rule del fwmark 111 lookup 100");

        }

    }

    if(if_table_tproxy()){
        echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Clean table tproxy\n";
        shell_exec("$ip route del local 0.0.0.0/0 dev lo table 100");
    }

    $pid=start_transparent_pid();

    if(!$unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance Already stopped\n";
        return true;
    }

    $tempfile=$unix->FILE_TEMP();
    if($unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance pid $pid\n";
        shell_exec("/usr/sbin/hacluster-transparent -f /etc/hacluster/tproxy.conf -k shutdown >$tempfile 2>&1");
        if(stop_transparent_check_stopped($tempfile)){
            sleep(1);
        }
    }
    sleep(1);
    $pid=start_transparent_pid();
    if(!$unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance success\n";
        return stop_transparent_childs();
    }

    for($i=0;$i<5;$i++){
        echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance ($i/5)\n";
        shell_exec("/usr/sbin/hacluster-transparent -f /etc/hacluster/tproxy.conf -k shutdown >$tempfile 2>&1");
        if(stop_transparent_check_stopped($tempfile)){
            sleep(1);
        }
        $pid=start_transparent_pid();
        if(!$unix->process_exists($pid)){
            echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance success\n";
            return stop_transparent_childs();
        }
        sleep(1);

    }

    return false;

}

function stop_transparent_childs(){
    $unix=new unix();
    $pids=stop_transparent_check_childs();
    if(count($pids)==0){
        echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance success (no child)\n";
        return true;
    }

    while( count($pids)>0 ){
        foreach ($pids as $pid){
            echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance kill child pid $pid\n";
            $unix->KILL_PROCESS($pid,9);
        }
        sleep(1);
        $pids=stop_transparent_check_childs();
    }
    echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance kill child(s) OK\n";
    return true;
}


function start_transparent()
{


    $HaClusterTransParentMode       = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));
    $HaClusterTransParentMasquerade = trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMasquerade"));

    if($HaClusterTransParentMode==0){
        echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance not enabled\n";
        if(is_file("/etc/init.d/hacluster-transparent")) {
            echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Uninstall Transparent service\n";
            start_transparent_uninstall_service();
        }

        return true;
    }

    $unix       = new unix();
    $ip         = $unix->find_program("ip");
    $iptables   = $unix->find_program("iptables");
    $squidbin   = $unix->LOCATE_SQUID_BIN();
    $echo       = $unix->find_program("echo");
    $rp_filter=2;
    $EnableVLANs=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableVLANs");
    if($EnableVLANs==1){$rpfilter=0;}

    echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Enable Kernel as Gateway\n";
    shell_exec("/sbin/sysctl -w net.ipv4.ip_nonlocal_bind=1 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.ip_forward=1 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.all.forwarding=1 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.all.accept_redirects=1 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.all.send_redirects=0 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.eth0.send_redirects=0 >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.default.rp_filter=$rpfilter >/dev/null 2>&1");
    shell_exec("/sbin/sysctl -w net.ipv4.conf.default.accept_source_route=1 >/dev/null 2>&1");

    $DETECTED = if_iptables_divert();
    echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} $DETECTED detected rules\n";
    if ($DETECTED > 5) {
        $DETECTED = 1;
    }


    if ($DETECTED < 5) {
        if ($DETECTED > 0) {
            stop_transparent();
        }


        echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Add Firewall rules.\n";
        shell_exec("$iptables -t mangle -N DIVERT >/dev/null 2>&1");
        shell_exec("$iptables -t mangle -A PREROUTING -p tcp -m socket -j DIVERT -m comment --comment \"HaCluster\"");
        shell_exec("$iptables -t mangle -A DIVERT -j MARK --set-mark 111 -m comment --comment \"HaCluster\"");
        shell_exec("$iptables -t mangle -A DIVERT -j ACCEPT -m comment --comment \"HaCluster\"");

        $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");
        $results=$q->QUERY_SQL("SELECT listen_ip FROM hacluster_backends");
        foreach ($results as $index=>$ligne){
            $listen_ip=$ligne["listen_ip"];
            echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} whitelist $listen_ip\n";
            shell_exec("$iptables -t mangle -A PREROUTING -p tcp -s $listen_ip -j RETURN -m comment --comment \"HaCluster\"");
        }


        shell_exec("$iptables -t mangle -A PREROUTING -p tcp --dport 80 -j TPROXY --tproxy-mark 111 --on-port 3154 --on-ip {$GLOBALS["tproxy_ip"]} -m comment --comment \"HaCluster\"");
        shell_exec("$iptables -t mangle -A PREROUTING -p tcp --dport 443 -j TPROXY --tproxy-mark 111 --on-port 3155 --on-ip {$GLOBALS["tproxy_ip"]} -m comment --comment \"HaCluster\"");
    }


    if (!if_ip_rule()) {

        echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Add IP rule MARK 111\n";
        shell_exec("$ip rule add fwmark 111 lookup 100");

    }

    if (!if_table_tproxy()) {
        echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Populate table tproxy\n";
        echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} $ip route add local 0.0.0.0/0 dev lo table 100\n";
        shell_exec("$ip route add local 0.0.0.0/0 dev lo table 100");
        echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Done...\n";
    }

    if($HaClusterTransParentMasquerade==1){
        if (!if_masquerade()) {
            echo "Reconfiguring.: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} MASQUERADE...\n";
            shell_exec("$iptables -t nat -A POSTROUTING -j MASQUERADE -m comment --comment \"HaCluster\"");
        }

    }else{
        shell_exec("$iptables -t nat -D POSTROUTING -j MASQUERADE -m comment --comment \"HaCluster\"");

    }


    start_transparent_squid_config();
    if(!is_file("/etc/init.d/hacluster-transparent")) {
        start_transparent_install_service();
    }



    if (is_file("/usr/sbin/hacluster-transparent")) {
        @unlink("/usr/sbin/hacluster-transparent");
    }
    @copy($squidbin, "/usr/sbin/hacluster-transparent");
    @chmod("/usr/sbin/hacluster-transparent", 0755);

    $pid = start_transparent_pid();
    if ( $unix->process_exists($pid) ) {
        echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance already running\n";
        shell_exec("/usr/sbin/hacluster-transparent -f /etc/hacluster/tproxy.conf -k reconfigure >/dev/null 2>&1");
        return true;
    }
    shell_exec("$echo \"\" >/var/log/hacluster/cache.log");
    @chown("/var/log/hacluster/cache.log","squid");
    @chgrp("/var/log/hacluster/cache.log","squid");
    echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance...\n";
    shell_exec("/usr/sbin/hacluster-transparent -f /etc/hacluster/tproxy.conf >/dev/null 2>&1");
    sleep(1);


    $pid = start_transparent_pid();
    if ( $unix->process_exists($pid) ) {
        echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Transparent instance sucess PID $pid\n";
        return true;
    }


    return false;
}

function start_transparent_pid(){
    $unix=new unix();
    $pid=$unix->get_pid_from_file("/var/run/hacluster/squid.pid");
    if($unix->process_exists($pid )){return $pid;}
    return $unix->PIDOF("/usr/sbin/hacluster-transparent");
}

function if_masquerade(){
    $unix=new unix();
    $iptables_save=$unix->find_program("iptables-save");
    exec("$iptables_save 2>&1",$results);
    foreach ($results as $line) {
        if(preg_match("#-A POSTROUTING\s+.*?\s+-j MASQUERADE#",$line)){
            return true;
        }
    }
}

function if_iptables_divert(){

    $unix=new unix();
    $iptables_save=$unix->find_program("iptables-save");
    exec("$iptables_save 2>&1",$results);
    echo "Reconfiguring.: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Firewall ". count($results)." rules\n";
    $DETECTED=0;
    foreach ($results as $line) {
        $line = trim($line);
        if ($line == null) {
            continue;
        }

        if(preg_match("#-A PREROUTING -p tcp -m socket -m comment#i",$line)){
            $DETECTED++;
            continue;
        }

        if(preg_match("#-A DIVERT -m comment --comment HaCluster -j MARK --set-xmark#i",$line)){
            $DETECTED++;
            continue;
        }

        if(preg_match("#-A DIVERT -m comment --comment HaCluster -j ACCEPT#i",$line)){
            $DETECTED++;
            continue;
        }

        if(preg_match("#-A PREROUTING -p tcp -m tcp --dport 80 -m comment --comment HaCluster#",$line)){
            $DETECTED++;
        }
        if(preg_match("#-A PREROUTING -p tcp -m tcp --dport 443 -m comment --comment HaCluster#",$line)){
            $DETECTED++;
        }
    }

    return $DETECTED;


}

function if_table_tproxy(){
    $unix=new unix();
    $ip=$unix->find_program("ip");
    exec("$ip route show table 100 2>&1",$results);
    foreach ($results as $line) {
        $line = trim($line);
        if ($line == null) {
            continue;
        }
        if (preg_match("#local default dev lo#i", $line)) {
            return true;
        }
    }

    return false;
}

function if_ip_rule(){

    $unix=new unix();
    $ip=$unix->find_program("ip");
    exec("$ip rule show 2>&1",$results);

    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#from all fwmark 0x6f lookup tproxy#i",$line)){return true;}
    }
    return false;


}


function rsyslog_conf(){
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.syslog-engine.php --rsylogd >/dev/null 2>&1 &");
}




