<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}

include_once("/usr/share/artica-postfix/ressources/class.tcpip.inc");

if($argv[1]=="--ipset"){create_ipset();exit;}
if($argv[1]=="--firewall"){firewall_build();exit;}
if($argv[1]=="--install"){install();exit;}
if($argv[1]=="--uninstall"){uninstall();exit;}
if($argv[1]=="--start"){start();exit;}
if($argv[1]=="--stop"){stop();exit;}
if($argv[1]=="--restart"){restart();exit;}

function build_progress_firewall($text,$pourc){
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.progress";
    $array["POURC"]=$pourc;$array["TEXT"]=$text;
    @file_put_contents($PROGRESS_FILE, serialize($array));@chmod($PROGRESS_FILE,0755);
}
function build_progress_firewall_stop($text,$pourc){
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.stop.progress";
    $array["POURC"]=$pourc;$array["TEXT"]=$text;
    @file_put_contents($PROGRESS_FILE, serialize($array));@chmod($PROGRESS_FILE,0755);
}
function build_progress_firewall_start($text,$pourc){
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.start.progress";
    $array["POURC"]=$pourc;$array["TEXT"]=$text;
    @file_put_contents($PROGRESS_FILE, serialize($array));@chmod($PROGRESS_FILE,0755);
}
function restart(){
    stop();
    start();
}


function start(){

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NGINX_FW_STOPPED",0);
    build_progress_firewall_start("{starting}",20);
    if(!create_ipset()){
        build_progress_firewall_start("{failed}",110);
        echo "Failed to create ipset groups\n";
        return false;
    }
    build_progress_firewall_start("{starting}",80);
    if(!firewall_build()){
        build_progress_firewall_start("{failed}",110);
        echo "Failed to build Firewall rules...\n";
        return false;
    }

    build_progress_firewall_start("{success}",100);
    echo "Success to start Firewal for web services...\n";
}

function stop(){
    $unix=new unix();
    $ipset=$unix->find_program("ipset");
    echo "Deleting rules....\n";
    build_progress_firewall_stop("{stopping}",10);
    firewall_delete_rules();
    build_progress_firewall_stop("{stopping}",50);
    exec("$ipset destroy nginxfww 2>&1",$restore);
    foreach ($restore as $line){
        $line=trim($line);
        if($line==null){continue;}
        echo "Destroy nginxfww: $line\n";
    }
    build_progress_firewall_stop("{stopping}",90);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NGINX_FW_STOPPED",1);

    echo "Success to stop Firewal for web services...\n";
    build_progress_firewall_stop("{stopping}",100);
}

function install(){
    build_progress_firewall("{installing}",5);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginxFW",1);
    install_service();
    build_progress_firewall("{installing}",10);

    if(!create_ipset()){
        build_progress_firewall("{installing} {failed}",110);
    }

   if(!firewall_build()){
       $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginxFW",0);
       build_progress_firewall("{installing} {failed}",110);
       remove_service();
       return false;
   }

    $syslog[]="if  (\$msg contains 'fw-nginx-') then {";
    $syslog[]="\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/fw-nginx.log\")";
    $syslog[]="\t& stop";
    $syslog[]="}";
    @file_put_contents("/etc/rsyslog.d/fw-nginx.conf",@implode("\n",$syslog));
    shell_exec("/etc/init.d/rsyslog restart");

    build_progress_firewall("{installing} {success}",100);

}
function uninstall(){
    build_progress_firewall("{uninstalling}",5);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginxFW",0);
    remove_service();
    build_progress_firewall("{uninstalling} {success}",100);
}


function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}

function firewall_delete_rules(){
    $cachefile="/etc/artica-postfix/iptables-wordpress.conf";
    $unix=new unix();
    $iptables_save=$unix->find_program("iptables-save");
    shell_exec("$iptables_save > $cachefile");
    $datas=explode("\n",file_get_contents($cachefile));
    $pattern2="#comment\s+fw-nginx#";
    $conf=null;
    $NEWF=array();
    $d=0;

    foreach ($datas as $ligne){
        $ligne=trim($ligne);
        if($ligne==null){continue;}
        if(preg_match("#NGNIX_FW_DROP#",$ligne)){continue;}
        if(preg_match($pattern2,$ligne)){
            $d++;continue;
        }

        $NEWF[]=$ligne;
    }
    if($d>0) {
        $iptables_restore = $unix->find_program("iptables-restore");
        file_put_contents($cachefile, @implode("\n", $NEWF));
        system("$iptables_restore < $cachefile");
    }

    @unlink($cachefile);

}
function firewall_build(){

    $unix=new unix();
    build_progress_firewall("{remove_rules}",50);

    firewall_delete_rules();
    $iptables=$unix->find_program("iptables");
    $comment="-m comment --comment \"fw-nginx\"";
    $wwdata="-m owner --uid-owner www-data";
    $alsrcp="--sport 1024:65535";
    $grp="-m set --match-set nginxfww dst,dst";
    $multi="--match multiport --dports 80,443";

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NGINX_FW_TIMESTAMP",time());

    $network_get_all_ips=$unix->network_get_all_ips();

    // OUT=lo SRC=147.135.249.241 DST=147.135.249.241 LEN=60 TOS=0x00 PREC=0x00 TTL=64 ID=50468 DF PROTO=TCP SPT=24906 DPT=80

    $cmds[]="$iptables -N NGNIX_FW_DROP $comment";
    $cmds[]="$iptables -A NGNIX_FW_DROP $comment -j LOG --log-prefix fw-nginx-out:";
    $cmds[]="$iptables -A NGNIX_FW_DROP $comment -j DROP";

    $cmds[]="$iptables -I OUTPUT -p tcp $wwdata $comment --syn -j NGNIX_FW_DROP";
    $cmds[]="$iptables -I OUTPUT -p tcp -d 127.0.0.1 $wwdata $comment -j ACCEPT";
    $cmds[]="$iptables -I OUTPUT -p udp --dport 53 $alsrcp $wwdata $comment -j ACCEPT";

    echo "Firewall: Allow DNS to Internet, full access to 127.0.0.1\n";

    foreach ($network_get_all_ips as $addr){
        echo "Firewall: Allow loopback from $addr to $addr on port 80/443\n";
        $cmds[]="$iptables -I OUTPUT -o lo -p tcp -s $addr -d $addr $multi $wwdata $comment -j ACCEPT";

    }

    $cmds[]="$iptables -I OUTPUT $wwdata $grp $comment -j ACCEPT";

    build_progress_firewall("{configure}",60);

    foreach ($cmds as $commandline){
        echo $commandline."\n";
        shell_exec($commandline);
    }
    build_progress_firewall("{configure} {done}",70);
    return true;
}

function create_ipset(){

    $filename="/home/nginx-whitelist-ipset.txt";
    if(is_file($filename)){@unlink($filename);}
    $fh = fopen($filename, 'w');

    if(!if_nginxfww_found()) {
        fwrite($fh, "create nginxfww hash:ip,port family inet hashsize 1024 maxelem 100000\n");
    }
    $CountOfLines=0;

    $ipClass=new IP();

    $HOSTS[]="updates.theme-fusion.com";
    $HOSTS[]="avada.theme-fusion.com";
    $HOSTS[]="api.wordpress.org";

    fwrite($fh,"add nginxfww 216.58.204.0/23,tcp:80\n");$CountOfLines++;
    fwrite($fh,"add nginxfww 216.58.204.0/23,tcp:443\n");$CountOfLines++;


    foreach ($HOSTS as $hostname){
        $addr=gethostbyname($hostname);
        if(!$ipClass->isValid($addr)) {
            echo "Firewall: Allow to $hostname failed resolve host\n";
            continue;
        }
        fwrite($fh,"add nginxfww $addr,tcp:80\n");$CountOfLines++;
        fwrite($fh,"add nginxfww $addr,tcp:443\n");$CountOfLines++;
    }
    $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
    $results= $q->QUERY_SQL("SELECT * FROM networks_infos WHERE trusted=1 AND enabled=1");
    foreach ($results as $index => $ligne) {
        $maks=$ligne["ipaddr"];
        fwrite($fh,"add nginxfww $maks,tcp:80\n");$CountOfLines++;
        fwrite($fh,"add nginxfww $maks,tcp:443\n");$CountOfLines++;
    }

    build_progress_firewall("{configure}",20);
    $q=new lib_sqlite("/home/artica/SQLITE/wordpress.db");
    if($q->TABLE_EXISTS("wp_firewall")) {
        $results = $q->QUERY_SQL("SELECT * FROM wp_firewall ORDER BY address");
        foreach ($results as $index => $ligne) {
            $port = $ligne["port"];
            $address = $ligne["address"];

            if (!$ipClass->isIPAddressOrRange($ligne["address"])) {
                $address = gethostbyname($ligne["address"]);
            }

            if (!$ipClass->isIPAddressOrRange($address)) {
                echo "SKIP {$ligne["address"]}, no resolved...\n";
                continue;
            }

            fwrite($fh,"add nginxfww $address,tcp:$port\n");$CountOfLines++;

        }
    }

    @fclose($fh);
    $unix=new unix();
    $ipset=$unix->find_program("ipset");
    if(if_nginxfww_found()) {
        $restore[] = " - - - Flush - - - ";
        exec("$ipset flush nginxfww 2>&1", $restore);
    }
    $restore[]=" - - - Restore - - - ";
    exec("$ipset restore -! < $filename 2>&1",$restore);

    foreach ($restore as $line){
        $line=trim($line);
        if($line==null){continue;}
        echo "Compilation: $line\n";
    }

    echo "Added $CountOfLines records\n";



    if(!if_nginxfww_found()) {
        echo "Unable to find nginxfww ipset group\n";
        return false;
    }


    return true;
}

function if_nginxfww_found(){
    $unix=new unix();
    $ipset=$unix->find_program("ipset");
    exec("$ipset list -n 2>&1",$ipsetlist);
    foreach ($ipsetlist as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#^nginxfww#",$line)){
            return true;
        }

    }
}

function install_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/nginx-fw";
    $php5script=basename(__FILE__);
    $daemonbinLog="Firewall for NGinx";

    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:        ".basename($INITD_PATH);
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";

    $f[]="case \"\$1\" in";
    $f[]=" start)";
    $f[]="    ulimit -n 65536";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    ulimit -n 65536";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]=" reload)";
    $f[]="    ulimit -n 65536";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }

}