<?php
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){
    include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
}

include_once(dirname(__FILE__) . '/framework/class.unix.inc');
include_once(dirname(__FILE__) . '/framework/frame.class.inc');
include_once(dirname(__FILE__) . '/ressources/class.system.nics.inc');
include_once(dirname(__FILE__) . '/ressources/class.os.system.inc');

if($argv[1]=="--install"){$GLOBALS["OUTPUT"]=true;install();exit();}
if($argv[1]=="--uninstall"){$GLOBALS["OUTPUT"]=true;uninstall();exit();}

function install(){

    build_progress(10,"{installing}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUdevDaemon",1);
    build_progress(50,"{installing}");
    create_service();
    build_progress(90,"{installing}");
    shell_exec("/etc/init.d/udev start");
    build_progress(100,"{installing} {success}");

}

function uninstall(){
    build_progress(10,"{uninstalling}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUdevDaemon",0);
    remove_service("/etc/init.d/udev");
    build_progress(100,"{uninstalling} {success}");
}

function build_progress($pourc,$text){
    $date=date("Y-m-d H:i:s");
    $file="/usr/share/artica-postfix/ressources/logs/web/udev.service.progress";
    echo "$date: [{$pourc}%] $text\n";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($file, serialize($array));
    @chmod($file,0755);
}


function create_service(){

    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:          udev";
    $f[]="# Required-Start:    mountkernfs";
    $f[]="# Required-Stop:     umountroot";
    $f[]="# Default-Start:     S";
    $f[]="# Default-Stop:      0 6";
    $f[]="# Short-Description: Start systemd-udevd, populate /dev and load drivers.";
    $f[]="### END INIT INFO";
    $f[]="";
    $f[]="PATH=\"/sbin:/bin\"";
    $f[]="NAME=\"systemd-udevd\"";
    $f[]="DAEMON=\"/lib/systemd/systemd-udevd\"";
    $f[]="DESC=\"hotplug events dispatcher\"";
    $f[]="PIDFILE=\"/run/udev.pid\"";
    $f[]="CTRLFILE=\"/run/udev/control\"";
    $f[]="OMITDIR=\"/run/sendsigs.omit.d\"";
    $f[]="";
    $f[]="# we need to unmount /dev/pts/ and remount it later over the devtmpfs";
    $f[]="unmount_devpts() {";
    $f[]="  if mountpoint -q /dev/pts/; then";
    $f[]="    umount -n -l /dev/pts/";
    $f[]="  fi";
    $f[]="";
    $f[]="  if mountpoint -q /dev/shm/; then";
    $f[]="    umount -n -l /dev/shm/";
    $f[]="  fi";
    $f[]="}";
    $f[]="";
    $f[]="# mount a devtmpfs over /dev, if somebody did not already do it";
    $f[]="mount_devtmpfs() {";
    $f[]="  if grep -E -q \"^[^[:space:]]+ /dev devtmpfs\" /proc/mounts; then";
    $f[]="    mount -n -o remount,nosuid,size=\$tmpfs_size,mode=0755 -t devtmpfs devtmpfs /dev";
    $f[]="    return";
    $f[]="  fi";
    $f[]="";
    $f[]="  if ! mount -n -o nosuid,size=\$tmpfs_size,mode=0755 -t devtmpfs devtmpfs /dev; then";
    $f[]="    log_failure_msg \"udev requires devtmpfs support, not started\"";
    $f[]="    log_end_msg 1";
    $f[]="  fi";
    $f[]="";
    $f[]="  return 0";
    $f[]="}";
    $f[]="";
    $f[]="create_dev_makedev() {";
    $f[]="  if [ -e /sbin/MAKEDEV ]; then";
    $f[]="    ln -sf /sbin/MAKEDEV /dev/MAKEDEV";
    $f[]="  else";
    $f[]="    ln -sf /bin/true /dev/MAKEDEV";
    $f[]="  fi";
    $f[]="}";
    $f[]="";
    $f[]="# shell version of /usr/bin/tty";
    $f[]="my_tty() {";
    $f[]="  [ -x /bin/readlink ] || return 0";
    $f[]="  [ -e /proc/self/fd/0 ] || return 0";
    $f[]="  readlink --silent /proc/self/fd/0 || true";
    $f[]="}";
    $f[]="";
    $f[]="warn_if_interactive() {";
    $f[]="  if [ \"\$RUNLEVEL\" = \"S\" -a \"\$PREVLEVEL\" = \"N\" ]; then";
    $f[]="    return";
    $f[]="  fi";
    $f[]="";
    $f[]="  TTY=\$(my_tty)";
    $f[]="  if [ -z \"\$TTY\" -o \"\$TTY\" = \"/dev/console\" -o \"\$TTY\" = \"/dev/null\" ]; then";
    $f[]="    return";
    $f[]="  fi";
    $f[]="";
    $f[]="  printf \"\n\n\nIt has been detected that the command\n\n\t\$0 \$*\n\n\"";
    $f[]="  printf \"has been run from an interactive shell.\n\"";
    $f[]="  printf \"It will probably not do what you expect, so this script will wait\n\"";
    $f[]="  printf \"60 seconds before continuing. Press ^C to stop it.\n\"";
    $f[]="  printf \"RUNNING THIS COMMAND IS HIGHLY DISCOURAGED!\n\n\n\n\"";
    $f[]="  sleep 60";
    $f[]="}";
    $f[]="";
    $f[]="make_static_nodes() {";
    $f[]="  [ -e /lib/modules/\$(uname -r)/modules.devname ] || return 0";
    $f[]="  [ -x /bin/kmod ] || return 0";
    $f[]="";
    $f[]="  /bin/kmod static-nodes --format=tmpfiles --output=/proc/self/fd/1 | while read type name mode uid gid age arg; do";
    $f[]="    [ -e \$name ] && continue";
    $f[]="    case \"\$type\" in";
    $f[]="      c|b|c!|b!) mknod -m \$mode \$name \$type \$(echo \$arg | sed 's/:/ /') ;;";
    $f[]="      d|d!) mkdir \$name ;;";
    $f[]="      *) echo \"unparseable line (\$type \$name \$mode \$uid \$gid \$age \$arg)\" >&2 ;;";
    $f[]="    esac";
    $f[]="";
    $f[]="    if [ -x /sbin/restorecon ]; then";
    $f[]="      /sbin/restorecon \$name";
    $f[]="    fi";
    $f[]="  done";
    $f[]="}";
    $f[]="";
    $f[]="";
    $f[]="##############################################################################";
    $f[]="";
    $f[]="";
    $f[]="[ -x \$DAEMON ] || exit 0";
    $f[]="";
    $f[]="# defaults";
    $f[]="tmpfs_size=\"10M\"";
    $f[]="";
    $f[]="if [ -e /etc/udev/udev.conf ]; then";
    $f[]="  . /etc/udev/udev.conf";
    $f[]="fi";
    $f[]="";
    $f[]=". /lib/lsb/init-functions";
    $f[]="";
    $f[]="if [ ! -e /proc/filesystems ]; then";
    $f[]="  log_failure_msg \"udev requires a mounted procfs, not started\"";
    $f[]="  log_end_msg 1";
    $f[]="fi";
    $f[]="";
    $f[]="if ! grep -q '[[:space:]]devtmpfs\$' /proc/filesystems; then";
    $f[]="  log_failure_msg \"udev requires devtmpfs support, not started\"";
    $f[]="  log_end_msg 1";
    $f[]="fi";
    $f[]="";
    $f[]="if [ ! -d /sys/class/ ]; then";
    $f[]="  log_failure_msg \"udev requires a mounted sysfs, not started\"";
    $f[]="  log_end_msg 1";
    $f[]="fi";
    $f[]="";
    $f[]="if [ ! -w /sys ]; then";
    $f[]="  log_warning_msg \"udev does not support containers, not started\"";
    $f[]="  exit 0";
    $f[]="fi";
    $f[]="";
    $f[]="if [ -d /sys/class/mem/null -a ! -L /sys/class/mem/null ] || [ -e /sys/block -a ! -e /sys/class/block ]; then";
    $f[]="  log_warning_msg \"CONFIG_SYSFS_DEPRECATED must not be selected\"";
    $f[]="  log_warning_msg \"Booting will continue in 30 seconds but many things will be broken\"";
    $f[]="  sleep 30";
    $f[]="fi";
    $f[]="";
    $f[]="# When modifying this script, do not forget that between the time that the";
    $f[]="# new /dev has been mounted and udevadm trigger has been run there will be";
    $f[]="# no /dev/null. This also means that you cannot use the \"&\" shell command.";
    $f[]="";
    $f[]="case \"\$1\" in";
    $f[]="    start)";
    $f[]="    if [ ! -e \"/run/udev/\" ]; then";
    $f[]="        warn_if_interactive";
    $f[]="    fi";
    $f[]="";
    $f[]="    if [ -w /sys/kernel/uevent_helper ]; then";
    $f[]="        echo > /sys/kernel/uevent_helper";
    $f[]="    fi";
    $f[]="";
    $f[]="    if ! mountpoint -q /dev/; then";
    $f[]="        unmount_devpts";
    $f[]="        mount_devtmpfs";
    $f[]="        [ -d /proc/1 ] || mount -n /proc";
    $f[]="    fi";
    $f[]="";
    $f[]="    make_static_nodes";
    $f[]="";
    $f[]="    # clean up parts of the database created by the initramfs udev";
    $f[]="    udevadm info --cleanup-db";
    $f[]="";
    $f[]="    # set the SELinux context for devices created in the initramfs";
    $f[]="    [ -x /sbin/restorecon ] && /sbin/restorecon -R /dev";
    $f[]="";
    $f[]="    log_daemon_msg \"Starting \$DESC\" \"\$NAME\"";
    $f[]="    if start-stop-daemon --start --name \$NAME --user root --quiet --pidfile \$PIDFILE --exec \$DAEMON --background --make-pidfile --notify-await; then";
    $f[]="        # prevents udevd to be killed by sendsigs (see #791944)";
    $f[]="        mkdir -p \$OMITDIR";
    $f[]="        ln -sf \$PIDFILE \$OMITDIR/\$NAME";
    $f[]="        log_end_msg \$?";
    $f[]="    else";
    $f[]="        log_warning_msg \$?";
    $f[]="        log_warning_msg \"Waiting 15 seconds and trying to continue anyway\"";
    $f[]="        sleep 15";
    $f[]="    fi";
    $f[]="";
    $f[]="    log_action_begin_msg \"Synthesizing the initial hotplug events (subsystems)\"";
    $f[]="    if udevadm trigger --type=subsystems --action=add; then";
    $f[]="        log_action_end_msg \$?";
    $f[]="    else";
    $f[]="        log_action_end_msg \$?";
    $f[]="    fi";
    $f[]="    log_action_begin_msg \"Synthesizing the initial hotplug events (devices)\"";
    $f[]="    if udevadm trigger --type=devices --action=add; then";
    $f[]="        log_action_end_msg \$?";
    $f[]="    else";
    $f[]="        log_action_end_msg \$?";
    $f[]="    fi";
    $f[]="";
    $f[]="    create_dev_makedev";
    $f[]="";
    $f[]="    # wait for the systemd-udevd childs to finish";
    $f[]="    log_action_begin_msg \"Waiting for /dev to be fully populated\"";
    $f[]="    if udevadm settle; then";
    $f[]="        log_action_end_msg 0";
    $f[]="    else";
    $f[]="        log_action_end_msg 0 'timeout'";
    $f[]="    fi";
    $f[]="    ;;";
    $f[]="";
    $f[]="    stop)";
    $f[]="    log_daemon_msg \"Stopping \$DESC\" \"\$NAME\"";
    $f[]="    if start-stop-daemon --stop --name \$NAME --user root --quiet --pidfile \$PIDFILE --remove-pidfile --oknodo --retry 5; then";
    $f[]="        # prevents cryptsetup/dmsetup hangs (see #791944)";
    $f[]="        rm -f \$CTRLFILE";
    $f[]="        log_end_msg \$?";
    $f[]="    else";
    $f[]="        log_end_msg \$?";
    $f[]="    fi";
    $f[]="    ;;";
    $f[]="";
    $f[]="    restart)";
    $f[]="    log_daemon_msg \"Stopping \$DESC\" \"\$NAME\"";
    $f[]="    if start-stop-daemon --stop --name \$NAME --user root --quiet --pidfile \$PIDFILE --remove-pidfile --oknodo --retry 5; then";
    $f[]="        # prevents cryptsetup/dmsetup hangs (see #791944)";
    $f[]="        rm -f \$CTRLFILE";
    $f[]="        log_end_msg \$?";
    $f[]="    else";
    $f[]="        log_end_msg \$? || true";
    $f[]="    fi";
    $f[]="";
    $f[]="    log_daemon_msg \"Starting \$DESC\" \"\$NAME\"";
    $f[]="    if start-stop-daemon --start --name \$NAME --user root --quiet --pidfile \$PIDFILE --exec \$DAEMON --background --make-pidfile --notify-await; then";
    $f[]="        # prevents udevd to be killed by sendsigs (see #791944)";
    $f[]="        mkdir -p \$OMITDIR";
    $f[]="        ln -sf \$PIDFILE \$OMITDIR/\$NAME";
    $f[]="        log_end_msg \$?";
    $f[]="    else";
    $f[]="        log_end_msg \$?";
    $f[]="    fi";
    $f[]="    ;;";
    $f[]="";
    $f[]="    reload|force-reload)";
    $f[]="    udevadm control --reload-rules";
    $f[]="    ;;";
    $f[]="";
    $f[]="    status)";
    $f[]="    status_of_proc \$DAEMON \$NAME && exit 0 || exit \$?";
    $f[]="    ;;";
    $f[]="";
    $f[]="    *)";
    $f[]="    echo \"Usage: /etc/init.d/udev {start|stop|restart|reload|force-reload|status}\" >&2";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="";
    $f[]="exit 0";
    $f[]="";
    @file_put_contents("/etc/init.d/udev",@implode("\n",$f));
    @chmod("/etc/init.d/udev",0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename("/etc/init.d/udev")." defaults >/dev/null 2>&1");

    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename("/etc/init.d/udev")." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename("/etc/init.d/udev")." on >/dev/null 2>&1");
    }
}

function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}