<?php
if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){
    include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
}
include_once("/usr/share/artica-postfix/framework/class.unix.inc");
include_once("/usr/share/artica-postfix/ressources/class.ccurl.inc");
$GLOBALS["VIAUN"]=false;
if(preg_match("#--viaun#",@implode(" ",$argv))){$GLOBALS["VIAUN"]=true;}

$GLOBALS["TITLENAME"]="DOH Backend";

if($argv[1]=="--install"){install();exit;}
if($argv[1]=="--update"){updateToLatest();exit;}
if($argv[1]=="--stop"){stop();exit;}
if($argv[1]=="--start"){start();exit;}
if($argv[1]=="--restart"){restart();exit;}
if($argv[1]=="--reload"){restart();exit;}


function build_progress($pourc,$text){
    $date=date("Y-m-d H:i:s");
    $file="/usr/share/artica-postfix/ressources/logs/web/doh.service.progress";
    echo "$date: [{$pourc}%] $text\n";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($file, serialize($array));
   @chmod($file,0755);
}

function restart(){

    stop();
    build();
    start();
}

function CurrentVersion(){

    exec("/usr/sbin/dnscrypt-proxy -V 2>&1",$results);
    foreach ($results as $line){
        if(preg_match("#dnscrypt-proxy\s+([0-9\.]+)#",$line,$re)){
            return trim($re[1]);
        }
    }
    exec("/usr/sbin/dnscrypt-proxy -version 2>&1",$results2);
    foreach ($results2 as $line){
        $line=trim($line);
        if(preg_match("#^([0-9\.]+)#",$line,$re)){
            return trim($re[1]);
        }
    }
}

function updateToLatest(){
    $unix=new unix();
    $DirDest="/etc/unbound-doh/Latest";
    if(!is_dir($DirDest)){@mkdir($DirDest,0755,true);}
    $FileDest=$DirDest."/latest.json";

    if(is_file($FileDest)){
        $Time=$unix->file_time_min($FileDest);
        if($Time>2880){@unlink_disk($FileDest);}
    }
    if(!is_file($FileDest)) {
        $curl = new ccurl("https://api.github.com/repos/DNSCrypt/dnscrypt-proxy/releases/latest");
        if(!$curl->GetFile($FileDest)){return;}
    }

    $json=json_decode(@file_get_contents($FileDest));
    $NextVer=null;
    $URL=null;
    foreach ($json->assets as $index=>$mainjson){
        if(preg_match("#dnscrypt-proxy-linux_x86_64-([0-9\.]+)\.tar.gz$#",trim($mainjson->browser_download_url),$re)){
            $NextVer=trim($re[1]);
            $URL=$mainjson->browser_download_url;
        }
    }


    $CurrentVer=CurrentVersion();
    echo "Testing $CurrentVer <> $NextVer\n";
    if($CurrentVer==$NextVer){return;}

    xout("Updating to $NextVer");
    $curl=new ccurl($URL);
    $TargetFile=$unix->TEMP_DIR()."/". basename($URL);
    $TargetDir=$unix->TEMP_DIR()."/$NextVer";
    if(!is_dir($TargetDir)){@mkdir($TargetDir,0755,true);}
    if(!$curl->GetFile($TargetFile)){
        xout("Downloading $URL failed");
        @unlink($TargetFile);
        @rmdir($TargetDir);
        return false;
    }

    $tar=$unix->find_program("tar");
    $rm=$unix->find_program("rm");
    xout("Extract to $TargetDir");
    xout("$tar xf $TargetFile -C $TargetDir/");
    shell_exec("$tar xf $TargetFile -C $TargetDir/");
    @unlink($TargetFile);

    $SourcePath="$TargetDir/linux-x86_64/dnscrypt-proxy";
    if(!is_file($SourcePath)){
        xout("Unable to stat $SourcePath");
        shell_exec("$rm -rf $TargetDir");
        return false;
    }

    if(is_file("/usr/sbin/dnscrypt-proxy")) {
        @unlink("/usr/sbin/dnscrypt-proxy");
    }

    if(!@copy($SourcePath,"/usr/sbin/dnscrypt-proxy")){
        $err=error_get_last();
        echo "Copy Failed $SourcePath to /usr/sbin/dnscrypt-proxy {$err["message"]}!!!\n";
        shell_exec("$rm -rf $TargetDir");
        return false;
    }

    @chmod("/usr/sbin/dnscrypt-proxy",0755);

    if(is_file("/usr/sbin/doh-backend")){
        @unlink("/usr/sbin/doh-backend");
        @copy($SourcePath,"/usr/sbin/doh-backend");
        @chmod("/usr/sbin/doh-backend",0755);
    }


    shell_exec("$rm -rf $TargetDir");
    return true;

}

function build_monit(){
    $f[]="check process APP_DOH_BACKEND with pidfile /var/run/doh-backend/doh-backend.pid";
    $f[]="\tstart program = \"/etc/init.d/doh-backend start\"";
    $f[]="\tstop program = \"/etc/init.d/doh-backend stop\"";
    $f[]="\tif failed host 127.0.0.1 port 5353 type udp protocol dns then restart";
    $f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_DOH_BACKEND.monitrc", @implode("\n", $f));
    if(!is_file("/etc/monit/conf.d/APP_DOH_BACKEND.monitrc")){
        echo "/etc/monit/conf.d/APP_DOH_BACKEND.monitrc failed !!!\n";
    }
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
}

function install(){
    $unix=new unix();
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUnboundDOHBackend",1);
    build_progress(10,"{updating}");
    updateToLatest();
    build_progress(15,"{installing}");
    $MD5A=md5_file("/usr/sbin/dnscrypt-proxy");
    $MD5B=md5_file("/usr/sbin/doh-backend");

    if($MD5A<>$MD5B){
        build_progress(20,"{installing}");
        if(is_file("/usr/sbin/doh-backend")){@unlink("/usr/sbin/doh-backend");}
        xout("Copy /usr/sbin/dnscrypt-proxy to /usr/sbin/doh-backend");
        if(!@copy("/usr/sbin/dnscrypt-proxy","/usr/sbin/doh-backend")){
            $err=error_get_last();
            build_progress(110,"{installing} {failed} {$err["message"]}");
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUnboundDOHBackend",0);
            return false;
        }
    }
    @chmod("/usr/sbin/doh-backend",0755);
    build_progress(30,"{installing}");
    create_service();
    build_progress(40,"{installing}");
    $php=$unix->LOCATE_PHP5_BIN();

    if(is_file("/etc/init.d/dnscrypt-proxy")){
        build_progress(45,"{installing}");
        shell_exec("/usr/share/artica-postfix/exec.DnsCryptProxy.php --uninstall");
    }


    shell_exec("$php /usr/share/artica-postfix/exec.syslog-engine.php --build-server");
    build();;
    build_progress(50,"{starting_service}");
    start();
    build_progress(60,"{starting_service}");
    build_monit();
    build_progress(70,"{starting_service}");
    if(!$GLOBALS["VIAUN"]) {
        shell_exec("$php /usr/share/artica-postfix/exec.unbound.php --build --reload-only");
    }
    build_progress(80,"{starting_service}");
    $unix->Popuplate_cron_make("unbound-doh","15 4 * * *",basename(__FILE__)." --update");
    shell_exec("/etc/init.d/cron reload");

    build_progress(100,"{installing} {success}");
}

function uninstall($noprogress=false){
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUnboundDOHBackend",0);
    if(!$noprogress){build_progress(15,"{uninstalling}");}
    remove_service("/etc/init.d/doh-backend");
    if(!$noprogress){build_progress(30,"{uninstalling}");}
    if(is_file("/etc/monit/conf.d/APP_DOH_BACKEND.monitrc")) {
        @unlink("/etc/monit/conf.d/APP_DOH_BACKEND.monitrc");
        shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
    }
    if(is_file("/etc/cron.d/unbound-doh")) {
        @unlink("/etc/cron.d/unbound-doh");
        shell_exec("/etc/init.d/cron reload");
    }
    if(is_file("/var/log/unbound-doh.log")){@unlink("/var/log/unbound-doh.log");}

    if(!$noprogress){build_progress(50,"{uninstalling}");}
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    shell_exec("$php /usr/share/artica-postfix/exec.unbound.php --build --reload-only");


    if(!$noprogress){ build_progress(100,"{uninstalling} {done}");}
}
function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}
function create_service(){

        $unix=new unix();
        $php=$unix->LOCATE_PHP5_BIN();
        $INITD_PATH="/etc/init.d/doh-backend";
        $php5script=__FILE__;
        $f[]="#!/bin/sh";
        $f[]="### BEGIN INIT INFO";
        $f[]="# Provides:         greensql-fw";
        $f[]="# Required-Start:    \$local_fs \$syslog";
        $f[]="# Required-Stop:     \$local_fs \$syslog";
        $f[]="# Should-Start:";
        $f[]="# Should-Stop:";
        $f[]="# Default-Start:     3 4 5";
        $f[]="# Default-Stop:      0 1 6";
        $f[]="# Short-Description: {$GLOBALS["TITLENAME"]}";
        $f[]="# chkconfig: - 80 75";
        $f[]="# description: {$GLOBALS["TITLENAME"]}";
        $f[]="### END INIT INFO";
        $f[]="";
        $f[]="case \"\$1\" in";
        $f[]=" start)";
        $f[]="    $php $php5script --start \$2 \$3";
        $f[]="    ;;";
        $f[]="";
        $f[]="  stop)";
        $f[]="    $php $php5script --stop \$2 \$3";
        $f[]="    ;;";
        $f[]="";
        $f[]="  reload)";
        $f[]="    $php $php5script --reload \$2 \$3";
        $f[]="    ;;";
        $f[]="";

        $f[]=" restart)";
        $f[]="    $php $php5script --restart \$2 \$3";
        $f[]="    ;;";
        $f[]="";
        $f[]=" reconfigure)";
        $f[]="    $php $php5script --build \$2 \$3";
        $f[]="    ;;";
        $f[]="";
        $f[]="  *)";
        $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
        $f[]="    exit 1";
        $f[]="    ;;";
        $f[]="esac";
        $f[]="exit 0\n";
        $f[]="";


        echo "{$GLOBALS["TITLENAME"]}: [INFO] Writing $INITD_PATH with new config\n";
        @unlink($INITD_PATH);
        @file_put_contents($INITD_PATH, @implode("\n", $f));
        @chmod($INITD_PATH,0755);

        if(is_file('/usr/sbin/update-rc.d')){
            shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
        }

        if(is_file('/sbin/chkconfig')){
            shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
            shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
        }
    }


function build(){
    if(!is_dir("/etc/doh-backend")){@mkdir("/etc/doh-backend",0755,true);}
    if(!is_dir("/var/run/doh-backend")){@mkdir("/var/run/doh-backend",0755,true);}
    $EnableipV6 = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));
    cloacking_rules();
    $f[]="server_names = []";
    $f[]="listen_addresses = ['127.0.0.1:5353']";
    $f[]="max_clients = 250";
    $f[]="# user_name = 'nobody'";
    $f[]="ipv4_servers = true";
    if($EnableipV6==1) {
        $f[] = "ipv6_servers = true";
    }else{
        $f[] = "ipv6_servers = false";
    }
    $f[]="dnscrypt_servers = false";
    $f[]="doh_servers = true";
    $f[]="require_dnssec = false";
    $f[]="require_nolog = true";
    $f[]="require_nofilter = false";
    $f[]="disabled_server_names = []";
    $f[]="force_tcp = false";

    $ini=new Bs_IniHandler();
    $ArticaProxySettings=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaProxySettings");
    $ini->loadString($ArticaProxySettings);
    if(!isset($ini->_params["PROXY"]["ArticaProxyServerEnabled"])){$ini->_params["PROXY"]["ArticaProxyServerEnabled"]=0;}
    $ArticaProxyServerEnabled=strtolower($ini->_params["PROXY"]["ArticaProxyServerEnabled"]);
    if($ArticaProxyServerEnabled==null){$ArticaProxyServerEnabled=0;}
    if($ArticaProxyServerEnabled=="no"){$ArticaProxyServerEnabled=0;}

    if($ArticaProxyServerEnabled==1) {
        $ArticaProxyServerName = $ini->_params["PROXY"]["ArticaProxyServerName"];
        if ($ArticaProxyServerName == null) {
            $ArticaProxyServerEnabled = 0;
        }
        $ArticaProxyServerPort = intval($ini->_params["PROXY"]["ArticaProxyServerPort"]);
        if ($ArticaProxyServerPort == 0) {
            $ArticaProxyServerEnabled = 0;
        }
    }

    if($ArticaProxyServerEnabled==1) {
        echo "Using Remote HTTP Proxy http://$ArticaProxyServerName:$ArticaProxyServerPort\n";
        $f[] = "http_proxy = 'http://$ArticaProxyServerName:$ArticaProxyServerPort'";
    }
    $f[]="timeout = 5000";
    $f[]="keepalive = 30";
    $f[]="blocked_query_response = 'hinfo'";
    $f[]="lb_strategy = 'p2'";
    $f[]="lb_estimator = true";
    $f[]="log_level = 2";
    $f[]="use_syslog = true";
    $f[]="cert_refresh_delay = 240";
    $f[]="# dnscrypt_ephemeral_keys = false";
    $f[]="# tls_disable_session_tickets = false";
    $f[]="# tls_cipher_suite = [52392, 49199]";
    $f[]="fallback_resolvers = ['9.9.9.9:53', '8.8.8.8:53']";
    $f[]="ignore_system_dns = true";
    $f[]="netprobe_timeout = 60";
    $f[]="netprobe_address = '9.9.9.9:53'";
    $f[]="offline_mode = false";
    $f[]="log_files_max_size = 10";
    $f[]="log_files_max_age = 7";
    $f[]="log_files_max_backups = 1";
    if($EnableipV6==0) {
        $f[] = "block_ipv6 = true";
    }else{
        $f[] = "block_ipv6 = false";
    }
    $f[]="block_unqualified = true";
    $f[]="block_undelegated = true";
    $f[]="reject_ttl = 600";
    $f[]="# forwarding_rules = 'forwarding-rules.txt'";
    $f[]="cloaking_rules = '/etc/doh-backend/cloaking-rules.txt'";
    $f[]="cloak_ttl = 600";
    $f[]="cache = true";

    $UnBoundCacheMinTTL = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMinTTL"));
    $UnBoundCacheMAXTTL = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMAXTTL"));
    $UnBoundCacheNEGTTL = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheNEGTTL"));

    if($UnBoundCacheMinTTL==0){$UnBoundCacheMinTTL=3600;}
    if($UnBoundCacheMAXTTL==0){$UnBoundCacheMAXTTL=172800;}
    if($UnBoundCacheNEGTTL==0){$UnBoundCacheNEGTTL=3600;}
    if($UnBoundCacheMinTTL==-1){$UnBoundCacheMinTTL=0;}
    if($UnBoundCacheMAXTTL==-1){$UnBoundCacheMAXTTL=0;}
    if($UnBoundCacheNEGTTL==-1){$UnBoundCacheNEGTTL=0;}


    $f[]="cache_size = 100000";
    $f[]="cache_min_ttl = $UnBoundCacheMinTTL";
    $f[]="cache_max_ttl = $UnBoundCacheMAXTTL";
    $f[]="cache_neg_min_ttl = $UnBoundCacheNEGTTL";
    $f[]="cache_neg_max_ttl = $UnBoundCacheMAXTTL";
    $f[]="";
    $f[]="";
    $f[]="[local_doh]";
    $f[]="";
    $f[]="[query_log]";
    $f[]="";
    $f[]="file = '/var/log/unbound-doh.log'";
    $f[]="format = 'tsv'";
    $f[]="ignored_qtypes = ['DNSKEY', 'NS','NXDOMAIN']";
    $f[]="";
    $f[]="";
    $f[]="[nx_log]";
    $f[]="  # file = 'nx.log'";
    $f[]="  format = 'tsv'";
    $f[]="";
    $f[]="";
    $f[]="";
    $f[]="##   example.com";
    $f[]="##   =example.com";
    $f[]="##   *sex*";
    $f[]="##   ads.*";
    $f[]="##   ads*.example.*";
    $f[]="##   ads*.example[0-9]*.com";
    $f[]="";
    $f[]="";
    $f[]="[blacklist]";
    $f[]="";
    $f[]="  # blacklist_file = 'blacklist.txt'";
    $f[]="  # log_file = 'blocked.log'";
    $f[]="  # log_format = 'tsv'";
    $f[]="";
    $f[]="";
    $f[]="[ip_blacklist]";
    $f[]="";
    $f[]="  # blacklist_file = 'ip-blacklist.txt'";
    $f[]="  # log_file = 'ip-blocked.log'";
    $f[]="  # log_format = 'tsv'";
    $f[]="";
    $f[]="";
    $f[]="[whitelist]";
    $f[]="  # whitelist_file = 'whitelist.txt'";
    $f[]="  # log_file = 'whitelisted.log'";
    $f[]="  # log_format = 'tsv'";
    $f[]="[schedules]";
    $f[]="[sources]";

    $f[]="[sources.'opennic']";
    $f[]="urls = ['https://raw.githubusercontent.com/DNSCrypt/dnscrypt-resolvers/master/v3/opennic.md', 'https://download.dnscrypt.info/resolvers-list/v3/opennic.md']";
     $f[]="minisign_key = 'RWQf6LRCGA9i53mlYecO4IzT51TGPpvWucNSCh1CBM0QTaLn73Y7GFO3'";
     $f[]="cache_file = 'opennic.md'";

    $f[]="";
    $f[]="  [sources.'public-resolvers']";
    $f[]="  urls = ['https://raw.githubusercontent.com/DNSCrypt/dnscrypt-resolvers/master/v2/public-resolvers.md', 'https://download.dnscrypt.info/resolvers-list/v2/public-resolvers.md']";
    $f[]="  cache_file = 'public-resolvers.md'";
    $f[]="  minisign_key = 'RWQf6LRCGA9i53mlYecO4IzT51TGPpvWucNSCh1CBM0QTaLn73Y7GFO3'";
    $f[]="  prefix = ''";
    $f[]="";
    $f[]="  ";
    $f[]="  [sources.'relays']";
    $f[]="  urls = ['https://raw.githubusercontent.com/DNSCrypt/dnscrypt-resolvers/master/v2/relays.md', 'https://download.dnscrypt.info/resolvers-list/v2/relays.md']";
    $f[]="  cache_file = 'relays.md'";
    $f[]="  minisign_key = 'RWQf6LRCGA9i53mlYecO4IzT51TGPpvWucNSCh1CBM0QTaLn73Y7GFO3'";
    $f[]="  refresh_delay = 72";
    $f[]="  prefix = ''";
    $f[]="";
    $f[]="  [sources.quad9-resolvers]";
    $f[]="  urls = ['https://www.quad9.net/quad9-resolvers.md']";
    $f[]="  minisign_key = 'RWQBphd2+f6eiAqBsvDZEBXBGHQBJfeG6G+wJPPKxCZMoEQYpmoysKUN'";
    $f[]="  cache_file = 'quad9-resolvers.md'";
    $f[]="  prefix = 'quad9-'";
    $f[]="";
    $f[]="  [sources.'parental-control']";
    $f[]="  urls = ['https://raw.githubusercontent.com/DNSCrypt/dnscrypt-resolvers/master/v2/parental-control.md', 'https://download.dnscrypt.info/resolvers-list/v2/parental-control.md']";
    $f[]="  cache_file = 'parental-control.md'";
    $f[]="  minisign_key = 'RWQf6LRCGA9i53mlYecO4IzT51TGPpvWucNSCh1CBM0QTaLn73Y7GFO3'";
    $f[]="";
    $f[]="";
    $f[]="";
    $f[]="#########################################";
    $f[]="#        Servers with known bugs        #";
    $f[]="#########################################";
    $f[]="";
    $f[]="[broken_implementations]";
    $f[]="";
    $f[]="fragments_blocked = ['cisco', 'cisco-ipv6', 'cisco-familyshield', 'cisco-familyshield-ipv6', 'quad9-dnscrypt-ip4-filter-alt', 'quad9-dnscrypt-ip4-filter-pri', 'quad9-dnscrypt-ip4-nofilter-alt', 'quad9-dnscrypt-ip4-nofilter-pri', 'quad9-dnscrypt-ip6-filter-alt', 'quad9-dnscrypt-ip6-filter-pri', 'quad9-dnscrypt-ip6-nofilter-alt', 'quad9-dnscrypt-ip6-nofilter-pri', 'cleanbrowsing-adult', 'cleanbrowsing-family-ipv6', 'cleanbrowsing-family', 'cleanbrowsing-security']";
    $f[]="";
    $f[]="[doh_client_x509_auth]";
    $f[]="";
    $f[]="#";
    $f[]="# creds = [";
    $f[]="#    { server_name='myserver', client_cert='client.crt', client_key='client.key' }";
    $f[]="# ]";
    $f[]="";
    $f[]="";
    $f[]="";
    $f[]="[anonymized_dns]";
    $f[]="";
    $f[]="";
    $f[]="# routes = [";
    $f[]="#    { server_name='example-server-1', via=['anon-example-1', 'anon-example-2'] },";
    $f[]="#    { server_name='example-server-2', via=['sdns://gRIxMzcuNzQuMjIzLjIzNDo0NDM'] }";
    $f[]="# ]";
    $f[]="";
    $f[]="skip_incompatible = false";
    $f[]="";
    $f[]="";
    $f[]="";
    $f[]="";
    $f[]="[dns64]";
    $f[]="";
    $f[]="";
    $f[]="[static]";
    $f[]="";
    $f[]="  # [static.'myserver']";
    $f[]="  # stamp = 'sdns:AQcAAAAAAAAAAAAQMi5kbnNjcnlwdC1jZXJ0Lg'";
    xout("/etc/doh-backend/doh.toml done");
    @file_put_contents("/etc/doh-backend/doh.toml",@implode("\n",$f));

}

function xout($text){
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $text\n";
}
function xin($text){
    echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $text\n";
}
function start($aspid=false){
    $unix=new unix();
    $Masterbin="/usr/sbin/doh-backend";

    if(is_file("/etc/init.d/dnscrypt-proxy")){
        remove_service("/etc/init.d/dnscrypt-proxy");
    }

    if(!is_file($Masterbin)){
        xout("doh-backend not installed");
        return false;
    }

    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            xout("Already Artica task running PID $pid since {$time}mn");
            return true;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();

    if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
        xout("Service already started $pid since {$timepid}Mn...");
        @file_put_contents("/var/run/doh-backend/doh-backend.pid", $pid);
        return true;
    }

    $nohup=$unix->find_program("nohup");
    $CMDS[]="-config /etc/doh-backend/doh.toml";
    $CMDS[]="-pidfile /var/run/doh-backend/doh-backend.pid";
    $CMDS[]="-syslog";


    $cmd="$nohup $Masterbin ".@implode(" ", $CMDS)." >/dev/null 2>&1 &";
    xout("service");
    shell_exec($cmd);

    for($i=1;$i<5;$i++){
        xout("waiting $i/5");
        sleep(1);
        $pid=PID_NUM();
        if($unix->process_exists($pid)){break;}
    }

    $pid=PID_NUM();
    if($unix->process_exists($pid)) {
        xout("Success PID $pid");
        return true;
    }

    xout("Failed");
    xout("$cmd");
    return false;


}

function PID_NUM(){
    $unix=new unix();
    $pid=$unix->get_pid_from_file("/var/run/doh-backend/doh-backend.pid");
    if($unix->process_exists($pid)){return $pid;}
    $Masterbin=$unix->find_program("doh-backend");
    return $unix->PIDOF($Masterbin);
}
function stop($aspid=false){
    $unix=new unix();
    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            xin("service Already Artica task running PID $pid since {$time}mn");
            return;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();


    if(!$unix->process_exists($pid)){
        xin("service already stopped...");
        return;
    }
    $pid=PID_NUM();
    xin("service Shutdown pid $pid...");
    unix_system_kill($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        xin("service waiting pid:$pid $i/5...");
        sleep(1);
    }

    $pid=PID_NUM();
    if(!$unix->process_exists($pid)){
        xin("service success...");
        return;
    }

    xin("service shutdown - force - pid $pid");
    unix_system_kill_force($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        xin("service waiting pid:$pid $i/5...");
        sleep(1);
    }

    if($unix->process_exists($pid)){
        xin("service failed...");
        return;
    }

}


function cloacking_rules(){
    $unix=new unix();
    $EnableDuckduckgoSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDuckduckgoSafeSearch"));
    $EnableQwantSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableQwantSafeSearch"));
    $EnableBingSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableBingSafeSearch"));
    $EnableYoutubeSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableYoutubeSafeSearch"));
    $EnbaleYoutubeModerate = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnbaleYoutubeModerate"));

    if (!$unix->CORP_LICENSE()) {
        $EnableDuckduckgoSafeSearch = 0;
        $EnableQwantSafeSearch = 0;
        $EnableBingSafeSearch = 0;
        $EnableYoutubeSafeSearch = 0;
        $EnbaleYoutubeModerate = 0;
        $EnableGoogleSafeSearch = 0;
    }

    if($EnableGoogleSafeSearch==1) {
        $f[] = "www.google.*             forcesafesearch.google.com";
    }
    if($EnableBingSafeSearch==1) {
        $f[] = "www.bing.com             strict.bing.com";
    }
    $f[]="yandex.ru                familysearch.yandex.ru";
    if($EnableDuckduckgoSafeSearch==1) {
        $f[] = "=duckduckgo.com          safe.duckduckgo.com";
    }

    if($EnableQwantSafeSearch==1) {
        $f[] = "www.qwant.com   safeapi.qwant.com";
    }

    if($EnableYoutubeSafeSearch==1) {
        $prefix="restrict";
        if ($EnbaleYoutubeModerate == 1) {
            $prefix = "restrictmoderate";
        }
         $f[] = "www.youtube.com          $prefix.youtube.com";
         $f[] = "m.youtube.com            $prefix.youtube.com";
         $f[] = "youtubei.googleapis.com  $prefix.youtube.com";
         $f[] = "youtube.googleapis.com   $prefix.youtube.com";
         $f[] = "www.youtube-nocookie.com $prefix.youtube.com";
    }
    $f[]="localhost                127.0.0.1";
    $f[]="localhost                ::1";
    xout("/etc/doh-backend/cloaking-rules.txt done");
    @file_put_contents("/etc/doh-backend/cloaking-rules.txt",@implode("\n",$f));
}

