#!/bin/bash
INPUT=/tmp/menu.sh.$$
OUTPUT=/tmp/output.sh.$$
trap "rm $OUTPUT; rm $INPUT; exit" SIGHUP SIGINT SIGTERM
DIALOG=${DIALOG=dialog}
function Updatep(){
	/usr/bin/python /usr/share/artica-postfix/menu.update.py --generate
	/tmp/menu.update.sh
}
function BackupRestorep(){
	/usr/bin/php /usr/share/artica-postfix/exec.menu.snapshots.php --menu
	/tmp/bash_snapshots_menu.sh
}

function SSH_SERVICE_UNINSTALL(){
	/usr/bin/dialog --title "Uninstall SSH service" --yesno "This operation will uninstall the SSH service\nDo you need to perform this operation ?\nPress 'Yes' to continue, or 'No' to exit" 0 0
	return_value=$?
	case $return_value in
		0)
		echo "Uninstall the SSH service"
		/usr/bin/php /usr/share/artica-postfix/exec.sshd.php --uninstall --dialog
		return;;
	esac
}
function SSH_SERVICE_INSTALL(){
	/usr/bin/dialog --title "Install SSH service" --yesno "This operation will install the SSH service\nPress 'Yes' to continue, or 'No' to exit" 0 0
	case $? in
		0)
		/usr/bin/php /usr/share/artica-postfix/exec.sshd.php --install --dialog
		return;;
	esac
}
function SSH_SERVICE(){
	if [ -f /etc/init.d/ssh ]
	then 
	   SSH_SERVICE_UNINSTALL
	   /usr/share/artica-postfix/logon.system.sh
	   exit
	fi
	SSH_SERVICE_INSTALL
	/usr/share/artica-postfix/logon.system.sh
	exit	  

}

function ResetSettingsINC(){

/usr/bin/dialog --title "Remove" --yesno "This operation will reset settings\nServer will be turned to DHCP and all services will be removed...\nPress 'Yes' to continue, or 'No' to exit" 0 0
	case $? in
		0)
		/usr/bin/php /usr/share/artica-postfix/exec.reset.php --confirm
		exit;;
	esac

}

function OPTIMIZE(){
	/usr/bin/dialog --title "Optimize your system" --yesno "This operation optimize only your system when using\n\n- SSD disks\n- Microsoft HyperV\n- VMWare ESXI\n- XenServer\n\n\nYou need to reboot after this operation\n\n\nDo you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit" 0 0
	case $? in
		0)
		/bin/echo 1 >/etc/artica-postfix/settings/Daemons/EnableSystemOptimize
		/usr/bin/php /usr/share/artica-postfix/exec.vmware.php --optimize
		return;;
	esac
}

function CleanLogsp(){
	/usr/bin/dialog --title "Clean the log directory" --yesno "Do you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit" 0 0
	case $? in
	0)
		chmod 0755 /usr/share/artica-postfix/bin/remove-artica-logs.sh
		for i in $(seq 0 20 80) ; do sleep 1; echo $i | /usr/bin/dialog --gauge "Please wait" 10 70 0; done
		echo 90 | /usr/bin/dialog --gauge "Running..." 10 70 0
		/usr/share/artica-postfix/bin/remove-artica-logs.sh >/dev/null 2>&1
		sleep 1
		echo 100 | /usr/bin/dialog --gauge "Please wait" 10 70 0
		sleep 1
		/usr/bin/dialog --title "Clean the log directory" --msgbox "Your log directory as been cleaned..."  0 0
		return;;
	1)
		return;;
	255)
		return;;
	esac
}

function PASSWDY(){
	passwd root
}

function UUID_RESET(){

  UUID1=`cat /etc/artica-postfix/settings/Daemons/SYSTEMID`

  /usr/bin/dialog --title "Generate a new uuid" --yesno "Warning, this operation should break the associated license (except for Gold license)\\nDo you need to perform this operation ?\\n Press 'Yes' to continue, or 'No' to exit" 0 0

  case $? in
  0)
    /usr/bin/php /usr/share/artica-postfix/exec.menu.ips.php --uuid
    UUID2=`cat /etc/artica-postfix/settings/Daemons/SYSTEMID`
    /usr/bin/dialog --title "New uuid generated" --msgbox "Old UUID: $UUID1\\nNew uuid: $UUID2"  0 0
    return;;
  1)
    return;;

  255)
    return;;

  esac

}

function SuperAdmin(){
	if [ -f /tmp/dns.log ]; then
		rm /tmp/dns.log
	fi
	/usr/bin/dialog --clear --title "Username" --inputbox "Enter the SuperAdmin username" 10 68 Manager 2> /etc/artica-postfix/WIZARUSERNAME
	case $? in
		1)
		rm /etc/artica-postfix/WIZARUSERNAME || true
		return
	esac

	WIZARUSERNAME = `cat /etc/artica-postfix/WIZARUSERNAME`
	/usr/bin/dialog --clear --insecure --passwordbox "ENTER SuperAdmin Password for authentication"  10 68 secret 2> /etc/artica-postfix/WIZARUSERNAMEPASSWORD
	case $? in
		1)
		rm /etc/artica-postfix/WIZARUSERNAME || true
		rm /etc/artica-postfix/WIZARUSERNAMEPASSWORD || true
		return
	esac
	
	/usr/bin/dialog --title "Change SuperAdmin Account" --yesno "Do you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit" 0 0
	case $? in
		0)
	if [ -f /tmp/dns.log ]; then
		rm /tmp/dns.log
	fi
	/usr/bin/php /usr/share/artica-postfix/exec.menu.system.php --SuperAdmin >/tmp/dns.log &
	/usr/bin/dialog --tailbox /tmp/dns.log  25 150
		rm /etc/artica-postfix/WIZARUSERNAME
		rm /etc/artica-postfix/WIZARUSERNAMEPASSWORD
		return;;
	1)
		rm /etc/artica-postfix/WIZARUSERNAME
		rm /etc/artica-postfix/WIZARUSERNAMEPASSWORD
		return;;
	255)
		rm /etc/artica-postfix/WIZARUSERNAME
		rm /etc/artica-postfix/WIZARUSERNAMEPASSWORD
		return;;
	esac
}
if [ -f /etc/artica-postfix/.TestDrive ]
then
    rm -f /etc/artica-postfix/.TestDrive
fi

touch /etc/artica-postfix/.TestDrive

if [ ! -f /etc/artica-postfix/.TestDrive ]
then
    /usr/bin/dialog --title "\Zb\Z1ERROR! ERROR!" --colors --infobox "\Zb\Z1Hard disk issue\nNo space left\nor no free inodes\nor partition in read-only\n\nPress OK to enter into the system"  0 0
    /bin/login.old
    exit 0
fi

while true
do
SSHINST="Install"
if [ -f /etc/init.d/ssh ]
	then 
	  SSHINST="Uninstall"
fi

/usr/bin/dialog --clear  --nocancel --backtitle "Artica System Menu" --title "[ S Y S T E M -  M E N U ]" --menu "You can use the UP/DOWN arrow keys
Choose the TASK" 20 100 10 PASSWD "System root password" SuperAdmin "Web interface SuperAdmin account" SSH "$SSHINST SSH service" RESET "Reset parameters" Update "Update tasks" BackupRestore "Backup and restore (snapshots)" CleanLogs "Clean the log partition" OPTIMIZE "System Optimization ( SSD Disks, HyperV, XenServer, VMWare )" UUID "Generate a new Unique identifier" Quit "Return to main menu" 2>"${INPUT}"
menuitem=$(<"${INPUT}")
case $menuitem in
OPTIMIZE) OPTIMIZE;;
BackupRestore) BackupRestorep;;
PASSWD) PASSWDY;;
SuperAdmin) SuperAdmin;;
Update) Updatep;;
CleanLogs) CleanLogsp;;
RESET) ResetSettingsINC;;
SSH) SSH_SERVICE;;
UUID) UUID_RESET;;
Quit) break;;
esac
done
