<?php


class ad_rootdse{
	public $mysql_error;
	public $ok=false;
	private $servername;
	private $port=389;
	private $password;
	private $username;
	private $ldap_connection;
	private $use_ssl=0;
	private $ldapbind;
	private $attributes = array('vendorName',
			'vendorVersion',
			'namingContexts',
			'altServer',
			'supportedExtension',
			'supportedControl',
			'supportedSASLMechanisms',
			'supportedLDAPVersion',
			'subschemaSubentry' );
	
	public function __construct($servername,$port,$username,$password,$use_ssl=0){
		
		$this->servername=$servername;
		$this->port=$port;
		$this->username=$username;
		$this->password=$password;
		$this->use_ssl=intval($use_ssl);
		
	}
	
	private function connect(){
	    $this->ok=true;

	    if(!preg_match("#^[0-9\.]+$#",$this->servername)){
	        $IPADDR=gethostbyname($this->servername);
            VERBOSE("{$this->servername} === {$IPADDR}", __LINE__);
            if($IPADDR==$this->servername){
                $this->ok=false;
                $this->mysql_error="<strong>{$this->servername}:{$this->port}</strong>:<br><strong>{CURLE_COULDNT_RESOLVE_HOST}</strong><br>{check_resolution_dns_engine}";
                return;
            }

        }

	    if($this->use_ssl==1){$this->port=636;}
		$fp=@fsockopen($this->servername, $this->port, $errno, $errstr, 2);
		if(!$fp){
			$this->ok=false;
			$this->mysql_error="<strong>{$this->servername}:{$this->port}</strong>:<br><strong>$errstr</strong>}";
			@fclose($fp);
			VERBOSE("{$this->servername}:{$this->port} $errstr", __LINE__);
			return false;
		}

        if($this->use_ssl==1){$this->servername="ldaps://$this->servername/";}
		$this->ldap_connection=ldap_connect($this->servername, $this->port );
		ldap_set_option($this->ldap_connection, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_set_option($this->ldap_connection, LDAP_OPT_REFERRALS, 0);
		
		$this->ldapbind=@ldap_bind($this->ldap_connection, "$this->username",$this->password);
		
		if(!$this->ldapbind){
			$this->ok=false;
			$errornumber= ldap_errno($this->ldap_connection);
			VERBOSE("{$this->servername}:{$this->port} ldap_bind FAILED", __LINE__);
			$this->mysql_error= "ERROR number : $errornumber failed to connect to ldap server ldap://{$this->servername}:{$this->port} right username $this->username";
			switch (ldap_errno($this->ldap_connection)) {
				case 0x31:
					$this->mysql_error=$this->mysql_error . "\nBad username or password. Please try again.";
					break;
				case 0x32:
					$this->mysql_error=$this->mysql_error . "\nInsufficient access rights.";
					break;
				case 81:
					$this->mysql_error=$this->mysql_error . "\nUnable to connect to the LDAP server\nplease,\nverify if ldap daemon is running\n or the ldap server address";
					break;
				case -1:
						
					break;
				default:
					$this->mysql_error=$this->mysql_error . "\nCould not bind to the LDAP server." ."\n". ldap_err2str($this->ldap_connection);
			}
			@ldap_close($this->ldap_connection);
			return;
		}
		
		return true;
	}
	
	public function nETBIOSName($suffix){

        $Suffix="CN=Partitions,CN=Configuration,$suffix";
        $pattern="(&(objectClass=crossRef)(nETBIOSName=*))";
        $this->connect();
        $this->ok = true;
        $sr=@ldap_search($this->ldap_connection, $Suffix, "$pattern",array("nETBIOSName"));
        if(!$sr){
            $error=ldap_err2str(ldap_errno($this->ldap_connection));
            $this->mysql_error=$error;
            @ldap_close($this->ldap_connection);
            $this->ok =false;
            return false;
        }
        $entries=ldap_get_entries($this->ldap_connection,$sr);
        if(!is_array($entries)){
            $error=ldap_err2str(ldap_errno($this->ldap_connection));
            $this->mysql_error=$error;
            $this->ok =false;
            return false;
        }

        if(!isset($entries[0]["netbiosname"][0])){
            $this->mysql_error="netbiosname attribute not found.";
            $this->ok =false;
            return false;
        }

        return $entries[0]["netbiosname"][0];

        return false;

    }


	public function RootDSE(){
		if(!function_exists('ldap_connect')){
			$this->ok=false;
			$this->mysql_error="ldap_connect, no such function.";
			return array();
		}
		if(!$this->connect()){return false;}
		
		
		VERBOSE("{$this->servername}:{$this->port} ldap_read(...", __LINE__);
		$result=@ldap_read($this->ldap_connection, "", "(objectClass=*)",$this->attributes);
		
		
		if (!$result) {
			
			$errornumber= ldap_errno($this->ldap_connection);
			$error=ldap_err2str($errornumber);
			VERBOSE("{$this->servername}:{$this->port} ldap_read($error", __LINE__);
			$this->ok=false;
			$this->mysql_error="Err.$errornumber, $error";
			@ldap_close($this->ldap_connection);
			return false;
			
		}
			
		$hash=ldap_get_entries($this->ldap_connection,$result);
		$RootDSE=$hash[0]["namingcontexts"][0];
		if(is_array($RootDSE)){return $RootDSE[0];}
		return $RootDSE;
		
	}
    public function RootDSEArray(){
        $this->ok=true;
        if(!function_exists('ldap_connect')){
            $this->ok=false;
            $this->mysql_error="ldap_connect, no such function.";
            return array();
        }
        if(!$this->connect()){return array();}


        VERBOSE("{$this->servername}:{$this->port} ldap_read(...", __LINE__);
        $result=@ldap_read($this->ldap_connection, "", "(objectClass=*)",$this->attributes);


        if (!$result) {

            $errornumber= ldap_errno($this->ldap_connection);
            $error=ldap_err2str($errornumber);
            VERBOSE("{$this->servername}:{$this->port} ldap_read($error", __LINE__);
            $this->ok=false;
            $this->mysql_error="Err.$errornumber, $error";
            @ldap_close($this->ldap_connection);
            return array();

        }

        $hash=ldap_get_entries($this->ldap_connection,$result);
        return $hash;

    }
	
}