<?php
include_once(dirname(__FILE__)."/class.squid.acls.useragents.inc");


class http_access_defaults{
	private $SquidDisableAllFilters=0;
	private $SquidUrgency=0;
	private $EnableKerbAuth=0;
	private $LockActiveDirectoryToKerberos=0;
	private $ActiveDirectoryEmergency=0;
	private $smartphones_port=0;
	private $SquidLdapAuthEnableGroups=0;
	private $LDAP_AUTH=0;
	private $SquidEnableIdentdServiceOnly=0;
	private $ProxyDedicateMicrosoftRules=0;
	private $AllowAllNetworksInSquid=0;
	private $BasicAuthenticatorEmergency=0;
	private $SquidAllowSmartPhones=0;
	private $EnableFakeAuth=0;
	private $AllowWindowsUpdates=0;
	private $LOGS=array();
	
	
	function __construct(){
		if(!is_file("/etc/artica-postfix/settings/Daemons/AllowWindowsUpdates")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("AllowWindowsUpdates", 1);}
		if(!is_file("/etc/artica-postfix/settings/Daemons/AllowAllNetworksInSquid")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("AllowAllNetworksInSquid", 1);}
		if(!is_file("/etc/artica-postfix/settings/Daemons/AllowSquidCompatibility")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("AllowSquidCompatibility", 1);}
		$this->AllowAllNetworksInSquid=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AllowAllNetworksInSquid"));
		$this->smartphones_port=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("smartphones_port"));
		$this->SquidDisableAllFilters=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDisableAllFilters"));
		$this->SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
		$this->EnableKerbAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth"));
		$this->ActiveDirectoryEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActiveDirectoryEmergency"));
		$this->LDAP_AUTH=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStandardLDAPAuth"));
		$this->LOGS[]="# SquidStandardLDAPAuth = $this->LDAP_AUTH";
		$EnableOpenLDAP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableOpenLDAP"));
        $this->LOGS[]="# EnableOpenLDAP = $EnableOpenLDAP";
		$this->SquidLdapAuthEnableGroups=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidLdapAuthEnableGroups"));
		$this->SquidEnableIdentdServiceOnly=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidEnableIdentdServiceOnly"));
		$this->ProxyDedicateMicrosoftRules=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ProxyDedicateMicrosoftRules"));
		$this->BasicAuthenticatorEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BasicAuthenticatorEmergency"));
		$this->SquidAllowSmartPhones=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidAllowSmartPhones"));
		$this->EnableFakeAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableFakeAuth"));
        $this->LockActiveDirectoryToKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
        if($this->LockActiveDirectoryToKerberos==1){$this->EnableKerbAuth=1;}
		$SquidRadiusAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidRadiusAuth"));
        $this->LOGS[]="# SquidRadiusAuth = $SquidRadiusAuth";

		if($EnableOpenLDAP==0){$this->LDAP_AUTH=0;$this->LOGS[]="# LDAP_AUTH = 0 caused by EnableOpenLDAP";}
		if($SquidRadiusAuth==1){$this->LDAP_AUTH=1;}
	}
	
	
	public function deny_ip_src(){
		$ipClass=new IP();
		$q=new mysql_squid_builder();
		if(!$q->TABLE_EXISTS("squid_ip_ban")){
			@file_put_contents("/etc/squid3/acls/DenyIPSrc", "\n");
			return;
		}
		$results=$q->QUERY_SQL("SELECT * FROM squid_ip_ban");
		while ($ligne = mysqli_fetch_assoc($results)) {
			$ip=$ligne["items"];
			if(!$ipClass->isIPAddressOrRange($ip)){continue;}
			$tt[]=$ip;
		}
		
		@file_put_contents("/etc/squid3/acls/DenyIPSrc", @implode("\n", $tt));
		
	}
	
	
	function build(){
		$EnableKerbAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth"));
		$AllowWindowsUpdates=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AllowWindowsUpdates"));
		$AllowSquidCompatibility=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AllowSquidCompatibility"));
        $SquidAllowRemotePorts=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidAllowRemotePorts"));
        $conf[]=@implode("\n",$this->LOGS);
		if($EnableKerbAuth==1){$this->SquidEnableIdentdServiceOnly=0;}
		
		$this->deny_ip_src();
		
		if($this->SquidDisableAllFilters==0){
			$conf[]="acl MyBlockedIPs src \"/etc/squid3/acls/DenyIPSrc\"";
		}

		if($AllowWindowsUpdates==1){
			$conf[]="http_access allow WindowsUpdates";
		}else{
			$conf[]="http_access deny WindowsUpdates all";
		}
		
		$conf[]="#--------- http_access: Authentication rules...";
		if($this->SquidUrgency==1){
			$conf[]="# Emergency mode";
			$conf[]="http_access allow all";
			return @implode("\n", $conf);
			
		}

		if($this->AllowAllNetworksInSquid==0){
			$conf[]="http_access deny !office_network";
		}
		
		$f=new useragents();
		$conf[]="#--------- Rules bases on UserAgents --------------";
		$conf[]=$f->ACLS_ALL();
		$conf[]=$this->WHITELISTED_AUTH_BROWSERS();
		
		if($this->SquidAllowSmartPhones==1){
			$conf[]="#--------- Allow mobiles phones to not be authenticated.";
			$conf[]="http_access allow MobilePhones";
		}
		$conf[]="#--------------------------------------------------";
		$conf[]="# LDAP Auth = {$this->LDAP_AUTH}";

		if($this->smartphones_port>0){
			$conf[]="#--------- Dedicated rule that allow Mobile phones (SSL is allowed for all)";
            if($SquidAllowRemotePorts==0) {$conf[]="http_access allow MyMobilesPort SSL_ports all";}
			$conf[]="http_access deny MyMobilesPort !MobilePhones";
		}

		if($SquidAllowRemotePorts==0) {
            $conf[] = "http_access deny HTTP !Safe_ports all";
            $conf[] = "http_access deny CONNECT !SSL_ports all";
        }
		
		if($this->SquidDisableAllFilters==0){
			$conf[]="http_access deny MyBlockedIPs";
			$conf[]="http_access deny blockedsites";
			$conf[]="http_access deny DomainsBlackLists";
			$conf[]="http_access deny NetworksBlackLists";
			
		}
		$NormalPorts=" NormalPorts ";
		$MyMobilesPort=null;
		
		if($this->smartphones_port>0){$MobilePhones="!MyMobilesPort ";}
		

		
		if($this->BasicAuthenticatorEmergency==1){
			$conf[]="# Basic Authenticator Emergency!";
			$this->LDAP_AUTH=0;
		}
		
		if($this->LDAP_AUTH==1){
			if($this->EnableKerbAuth==0){
				if($this->SquidLdapAuthEnableGroups==1){
					
					$conf[]="http_access deny $NormalPorts!group_password";
				}
			}
			
			$conf[]="http_access deny $NormalPorts!ldapauth\n";
		}
		
		
		if($this->SquidEnableIdentdServiceOnly==1){
			$this->EnableFakeAuth=0;
			$conf[]="http_access deny $NormalPorts!identhosts all";
				
		}
		if($this->ActiveDirectoryEmergency==1){
		    $conf[]="# Active Directory Emergency!";$this->EnableKerbAuth==0;
		}
        $IS_AUTHENTICATED=false;
        $UseNativeKerberosAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseNativeKerberosAuth"));
        $LockActiveDirectoryToKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
        if($UseNativeKerberosAuth==1){$IS_AUTHENTICATED=true;}
        if($this->EnableKerbAuth==1){$IS_AUTHENTICATED=true;}
        if($LockActiveDirectoryToKerberos==1){$IS_AUTHENTICATED=true;}

        $conf[] = "# LockActiveDirectoryToKerberos  = $LockActiveDirectoryToKerberos";
        $conf[] = "# UseNativeKerberosAuth          = $UseNativeKerberosAuth";
        $conf[] = "# EnableKerbAuth                 = $this->EnableKerbAuth";

        if(!$IS_AUTHENTICATED) {
            $conf[] = "# * * IS_AUTHENTICATED = False";
        }else{
            $conf[] = "# * * IS_AUTHENTICATED = True";
        }

		if($IS_AUTHENTICATED){
			$this->EnableFakeAuth=0;
			if($this->ActiveDirectoryEmergency==0){

			    if(!$this->ACL_AUTHENTICATED()){
			        squid_admin_mysql(1,"Active Directory: Missing ACL Authenticated(1) [action=reconfigure]",null,__FILE__,__LINE__);
			        include_once(dirname(__FILE__)."/class.squid.ntlm.inc");
                    $squid_ntlm=new squid_ntlm();
                    $squid_ntlm->build();
                }

                if(!$this->ACL_AUTHENTICATED()){
                    squid_admin_mysql(1,"Active Directory: Missing ACL Authenticated(2) [action=None]",null,__FILE__,__LINE__);
                    $conf[]="# * * * * * * * * * * * * * * * * * * * * * * * *";
                    $conf[]="# * * * * ACL_AUTHENTICATED --- > MISSING !!!!* * ";
                    $conf[]="# * * * * * * * * * * * * * * * * * * * * * * * *";
                    return @implode("\n", $conf);
                }

				$conf[]=$this->WHITELISTED_AUTH();
				$conf[]="http_access deny $NormalPorts!AUTHENTICATED\n";
				$office_network=null;
			}
		}
		if($this->EnableFakeAuth==1){
			
			$conf[]="http_access deny $NormalPorts!AUTHENTICATED\n";
			$office_network=null;
		}
		
		return @implode("\n", $conf);
		

	}

	private function ACL_AUTHENTICATED(){
	        $zz=explode("\n",@file_get_contents("/etc/squid3/authenticate.conf"));
            foreach ($zz as $zline) {
                $zline = trim($zline);
                if ($zline == null) {
                    continue;
                }
                if (preg_match("#^acl AUTHENTICATED#", $zline)) {
                    return true;
                }
            }
            return false;
	}
	
	private function WHITELISTED_AUTH(){
		$ipaddr_dest=array();
		$destdomains=array();
		$ipaddr=array();
		$macs=array();
		$SquidWhitelistAuthFrom=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidWhitelistAuthFrom"));
		$SquidWhitelistAuthTo=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidWhitelistAuthTo"));
		$IP=new IP();
		if($SquidWhitelistAuthFrom){
			if(count($SquidWhitelistAuthFrom>0)){
			    foreach ($SquidWhitelistAuthFrom as $index=>$ligne){
					if($IP->isIPAddressOrRange($index)){$ipaddr[]=$index;continue;}
					if($IP->IsvalidMAC($index)){$macs[]=$index;continue;}
				}
			}
		}
		if($SquidWhitelistAuthTo){
			if(count($SquidWhitelistAuthTo>0)){
			    foreach ($SquidWhitelistAuthTo as $index=>$ligne){
					if($IP->isIPAddressOrRange($index)){$ipaddr_dest[]=$index;continue;}
					$destdomains[]=$index;
				}
			}
		}		
		
		
		if(count($ipaddr)>0){
			$f[]="# WHITELISTED_AUTH: ".count($ipaddr)." <FROM> Network Elements";
			@file_put_contents("/etc/squid3/SquidWhitelistAuthFromNet.db", @implode("\n", $ipaddr));
			$f[]="acl SquidWhitelistAuthFromNet src \"/etc/squid3/SquidWhitelistAuthFromNet.db\"";
			$f[]="http_access allow SquidWhitelistAuthFromNet";
		}else{
			$f[]="# WHITELISTED_AUTH: 0 <FROM> Network Element";
		}
		if(count($ipaddr_dest)>0){
			$f[]="# WHITELISTED_AUTH: ".count($ipaddr_dest)." <TO> Network Elements";
			@file_put_contents("/etc/squid3/SquidWhitelistAuthToNet.db", @implode("\n", $ipaddr_dest));
			$f[]="acl SquidWhitelistAuthToNet dst \"/etc/squid3/SquidWhitelistAuthToNet.db\"";
			$f[]="http_access allow SquidWhitelistAuthToNet";
		}else{
			$f[]="# WHITELISTED_AUTH: 0 <TO> Network Element";
		}		
		if(count($destdomains)>0){
			$f[]="# WHITELISTED_AUTH: ".count($destdomains)." domains";
			@file_put_contents("/etc/squid3/SquidWhitelistAuthToDoms.db", @implode("\n", $ipaddr_dest));
			$f[]="acl SquidWhitelistAuthToDoms dstdomain \"/etc/squid3/SquidWhitelistAuthToDoms.db\"";
			$f[]="http_access allow SquidWhitelistAuthToDoms";
		}else{
			$f[]="# WHITELISTED_AUTH: 0 domains";
		}		
		
		if(count($macs)>0){
			$f[]="# WHITELISTED_AUTH: ".count($ipaddr)." MAC Elements";
			@file_put_contents("/etc/squid3/SquidWhitelistAuthFromMAC.db", @implode("\n", $macs));
			$f[]="acl SquidWhitelistAuthFromMAC src \"/etc/squid3/SquidWhitelistAuthFromMAC.db\"";
			$f[]="http_access allow SquidWhitelistAuthFromMAC";
		}else{
			$f[]="# WHITELISTED_AUTH: 0 MAC Element";
		}		
		
		
		return @implode("\n", $f);
	}
	

	
	private function WHITELISTED_AUTH_BROWSERS(){
		if($this->SquidUrgency==1){return null;}
		if(isset($GLOBALS[__CLASS__][__FUNCTION__])){return @implode("\n",$GLOBALS[__CLASS__][__FUNCTION__]);}
		$arrayUserAgents=array();

	
	
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$sql="SELECT pattern,PatternType FROM webfilters_blkwhlts WHERE blockType=5 and enabled=1";
		$results=$q->QUERY_SQL($sql);
		if($GLOBALS["VERBOSE"]){echo "DEBUG: WHITELISTED_AUTH webfilters_blkwhlts=".count($results)." rows\n";}
		foreach($results as $index=>$ligne){
			$www=trim($ligne["pattern"]);
			if($www==null){if($GLOBALS["VERBOSE"]){echo "DEBUG: WHITELISTED_AUTH webfilters_blkwhlts skip `{$ligne["pattern"]}` is null\n";}continue;}
			if(preg_match("#regex:(.+)#", $www,$re)){$www=$re[1];}else{$www=$this->StringToRegex($www);}
			if(isset($arrayUserAgents[$www])){continue;}
			$arrayUserAgents[$www]=1;
		}
	
		$f=array();
		foreach ($arrayUserAgents as $UserAgent=>$Notused){$f[]="$UserAgent";}
	
		if(count($f)>0){
			$GLOBALS[__CLASS__][__FUNCTION__]=$f;
			$conf[]="acl WhiteListedUserAgents browser \"/etc/squid3/WhiteListedUserAgents.acl\"";
			@file_put_contents("/etc/squid3/WhiteListedUserAgents.acl", @implode("\n", $f));
			$conf[]="http_access allow WhiteListedUserAgents";
			return @implode("\n",$conf);
		}
		
		return null;
	
	}

	
}