<?php
if(!isset($GLOBALS["DEBUG_MEMCACHE"])){$GLOBALS["DEBUG_MEMCACHE"]=false;}
class lib_memcached{
	
	public $MemCachedFound=false;
	private $Memcached;
	public $mysql_error;
	public $ok=false;
	private $memcached_exists=true;
	
	function __construct(){
		
		if(!class_exists("Memcached")){
			$this->memcached_exists=false;
			if(function_exists("WLOG")){WLOG("Memcached, no such class!");}
			
		}else{
			$this->memcached_exists=true;
			$this->Memcached = new Memcached();
			$this->Memcached->addServer('/var/run/memcached.sock', 0);
		}
	}
	
	public function allKeys(){
		$keys = $this->Memcached->getAllKeys();
		return $keys;

		
	}
	
	public function getKey($key){
		if(!$this->memcached_exists){
		    $this->ok=false;
		    return null;
        }
		$this->ok=true;
		$value=$this->Memcached->get($key);
		$resultCode=$this->Memcached->getResultCode();
		$Memcached=null;

        if ($resultCode==16) {
            $this->ok=false;
            $this->MemCachedFound=false;
            return null;
        }
		
		if ($resultCode<>0) {
			$this->ok=false;
			$this->MemCachedFound=false;
			$this->mysql_error=$this->ErrorCodeToString($resultCode);
            $line=__LINE__;
			$this->ToSyslog("[L.$line]: [$key] Code:$resultCode $this->mysql_error",__LINE__);
			return null;
		}

		if ($resultCode==0) {$this->MemCachedFound=true;}
		return $value;
		
	}
	
	private function VERBOSE($text,$line){
		if(!$GLOBALS["VERBOSE"]){return;}
		if(!function_exists("VERBOSE")){return;}
		VERBOSE($text, $line);
	}
	
	private function _getSettingFile($key){
		$FileKeyPath="/etc/artica-postfix/settings/Daemons/$key";
		if(!is_file($FileKeyPath)){return null;}
		if(!is_readable($FileKeyPath)){return null;}
		$value=trim(@file_get_contents($FileKeyPath));
		return $value;
	}
	
	public function getSetting($Key){
        $this->ok=true;
	    if(!$this->memcached_exists){
	        $this->ok=false;
		    return null;
		}
	    $value=$this->getKey("SET:$Key");
	    if(!$this->MemCachedFound){return null;}
	    return trim($value);
		
	}
	
	public function Statistics(){
		if(!$this->memcached_exists){return array();}
		return $this->Memcached->getStats();
	}
	
	public function SetSetting($key,$value){
		if(!$this->memcached_exists){return;}
        return $this->saveKey("SET:$key", $value,15778800);

	}
	
	public function Delkey($key){
		if(!$this->memcached_exists){return;}
		$this->Memcached->delete($key);
	}

    private function ToSyslog($text){

        $LOG_SEV=LOG_INFO;
        if(function_exists("openlog")){openlog("class.memcached.inc", LOG_PID , LOG_SYSLOG);}
        if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
        if(function_exists("closelog")){closelog();}
    }


    public function saveKey($key,$object,$ttl=0)
    {
        $this->ok = true;
        if (!$this->memcached_exists) {
            if ($GLOBALS["DEBUG_MEMCACHE"]) {
                if ($GLOBALS["VERBOSE"]) {
                    echo "Memcached did not exists...\n";
                }
            }
            $this->ok = false;
            return false;
        }


        if (!$this->Memcached->set($key, $object, $ttl)) {
            $this->ok = false;
            $resultCode = $this->Memcached->getResultCode();
            $line=__LINE__;
            $this->mysql_error = "$key Fatal: Code:$resultCode " . $this->ErrorCodeToString($resultCode);
            $this->ToSyslog("[L.$line]: $this->mysql_error");

        }

        return true;


    }
	

	private function ErrorCodeToString($int=0){
		$MEMERROR[intval("00")]="MEMCACHED_SUCCESS";
		$MEMERROR[intval("01")]="MEMCACHED_FAILURE";
		$MEMERROR[intval("02")]="MEMCACHED_HOST_LOOKUP_FAILURE // getaddrinfo() and getnameinfo() only";
		$MEMERROR[intval("03")]="MEMCACHED_CONNECTION_FAILURE";
		$MEMERROR[intval("04")]="MEMCACHED_CONNECTION_BIND_FAILURE // DEPRECATED see MEMCACHED_HOST_LOOKUP_FAILURE";
		$MEMERROR[intval("05")]="MEMCACHED_WRITE_FAILURE";
		$MEMERROR[intval("06")]="MEMCACHED_READ_FAILURE";
		$MEMERROR[intval("07")]="MEMCACHED_UNKNOWN_READ_FAILURE";
		$MEMERROR[intval("08")]="MEMCACHED_PROTOCOL_ERROR";
		$MEMERROR[intval("09")]="MEMCACHED_CLIENT_ERROR";
		$MEMERROR[intval("10")]="MEMCACHED_SERVER_ERROR";
		$MEMERROR[intval("11")]="MEMCACHED_ERROR";
		$MEMERROR[intval("12")]="MEMCACHED_DATA_EXISTS";
		$MEMERROR[intval("13")]="MEMCACHED_DATA_DOES_NOT_EXIST";
		$MEMERROR[intval("14")]="MEMCACHED_NOTSTORED";
		$MEMERROR[intval("15")]="MEMCACHED_STORED";
		$MEMERROR[intval("16")]="MEMCACHED_NOTFOUND";
		$MEMERROR[intval("17")]="MEMCACHED_MEMORY_ALLOCATION_FAILURE";
		$MEMERROR[intval("18")]="MEMCACHED_PARTIAL_READ";
		$MEMERROR[intval("19")]="MEMCACHED_SOME_ERRORS";
		$MEMERROR[intval("20")]="MEMCACHED_NO_SERVERS";
		$MEMERROR[intval("21")]="MEMCACHED_END";
		$MEMERROR[intval("22")]="MEMCACHED_DELETED";
		$MEMERROR[intval("23")]="MEMCACHED_VALUE";
		$MEMERROR[intval("24")]="MEMCACHED_STAT";
		$MEMERROR[intval("25")]="MEMCACHED_ITEM";
		$MEMERROR[intval("26")]="MEMCACHED_ERRNO";
		$MEMERROR[intval("27")]="MEMCACHED_FAIL_UNIX_SOCKET // DEPRECATED";
		$MEMERROR[intval("28")]="MEMCACHED_NOT_SUPPORTED";
		$MEMERROR[intval("29")]="MEMCACHED_NO_KEY_PROVIDED  Deprecated. Use MEMCACHED_BAD_KEY_PROVIDED! ";
		$MEMERROR[intval("30")]="MEMCACHED_FETCH_NOTFINISHED";
		$MEMERROR[intval("31")]="MEMCACHED_TIMEOUT";
		$MEMERROR[intval("32")]="MEMCACHED_BUFFERED";
		$MEMERROR[intval("33")]="MEMCACHED_BAD_KEY_PROVIDED";
		$MEMERROR[intval("34")]="MEMCACHED_INVALID_HOST_PROTOCOL";
		$MEMERROR[intval("35")]="MEMCACHED_SERVER_MARKED_DEAD";
		$MEMERROR[intval("36")]="MEMCACHED_UNKNOWN_STAT_KEY";
		$MEMERROR[intval("37")]="MEMCACHED_E2BIG";
		$MEMERROR[intval("38")]="MEMCACHED_INVALID_ARGUMENTS";
		$MEMERROR[intval("39")]="MEMCACHED_KEY_TOO_BIG";
		$MEMERROR[intval("40")]="MEMCACHED_AUTH_PROBLEM";
		$MEMERROR[intval("41")]="MEMCACHED_AUTH_FAILURE";
		$MEMERROR[intval("42")]="MEMCACHED_AUTH_CONTINUE";
		$MEMERROR[intval("43")]="MEMCACHED_PARSE_ERROR";
		$MEMERROR[intval("44")]="MEMCACHED_PARSE_USER_ERROR";
		$MEMERROR[intval("45")]="MEMCACHED_DEPRECATED";
		$MEMERROR[intval("46")]="MEMCACHED_IN_PROGRESS";
		$MEMERROR[intval("47")]="MEMCACHED_SERVER_TEMPORARILY_DISABLED";
		$MEMERROR[intval("48")]="MEMCACHED_SERVER_MEMORY_ALLOCATION_FAILURE";
		$MEMERROR[intval("49")]="MEMCACHED_MAXIMUM_RETURN";
		$MEMERROR[intval("11")]="MEMCACHED_CONNECTION_SOCKET_CREATE_FAILURE";
		return $MEMERROR[$int];
	}
	
}