<?php

class lib_sqlite{
	public $db_path="";
	public $last_id=0;
	var $ok=true;
	var $mysql_error;
	private $sql;
	public 	$array_field_relay_tls=array("none"=>"{none}",
			"may"=>"{Opportunistic_TLS}",
			"dane"=>"{DANE_SMTP}",
			"dane-only"=>"{DANE_ONLY}",
			"encrypt"=>"{Mandatory_TLS_encryption}",
			"verify"=>"{Mandatory_TLS_verification}",
			"secure"=>"{Secure_channel_TLS}");
	
	function __construct($database_path=null){
		$this->db_path=$database_path;
		
	}

	function FIELDS_TYPES($table){
        $ARRAY=array();
        $results=$this->QUERY_SQL("pragma table_info($table)");
        foreach ($results as $index=>$ligne){
            $ARRAY[$ligne["name"]]=strtoupper($ligne["type"]);

        }
        return $ARRAY;
    }
	
	public function FIELDS_LIST($table,$array=array()){
		$sql="SELECT m.name as tableName, p.name as columnName FROM sqlite_master m 
		left outer join pragma_table_info((m.name)) p on m.name <> p.name WHERE m.name='$table' order by tableName, columnName";
		$results=$this->QUERY_SQL($sql);
		if(!$this->ok){return false;}
		if(count($results)==0){return false;}
		foreach ($results as $index=>$ligne){
			if($GLOBALS["VERBOSE"]){echo "$table == {$ligne["columnName"]}<br>\n";}
			$array[]="FIELD:{$ligne["columnName"]}";
		}
		
		return $array;
	
	}
	
	public function FIELDS_LIST_FOR_QUERY($table){
		$sql="SELECT m.name as tableName, p.name as columnName FROM sqlite_master m
		left outer join pragma_table_info((m.name)) p on m.name <> p.name WHERE m.name='$table' order by tableName, columnName";
		$results=$this->QUERY_SQL($sql);
		if(!$this->ok){return false;}
		if(count($results)==0){return false;}
		foreach ($results as $index=>$ligne){
			$array[]="{$ligne["columnName"]}";
		}
		
		return $array;
		
	}

	public function INDEX_EXISTS($stable,$sindexname){


	    $md5=md5($this->db_path);
	    if(!isset($GLOBALS["INDEX_EXISTS"][$md5])) {

            $sql = "SELECT DISTINCT m.name || '.' || ii.name AS 'indexed-columns'
              FROM sqlite_master AS m,
                   pragma_index_list(m.name) AS il,
                   pragma_index_info(il.name) AS ii
             WHERE m.type = 'table'
             ORDER BY 1;";

            $results = $this->QUERY_SQL($sql);

            foreach ($results as $index=>$ligne){

                $info=$ligne["indexed-columns"];
                if(preg_match("#(.+?)\.(.+)#",$info,$re)){
                    $table=strtolower($re[1]);
                    $indexz=strtolower($re[2]);
                    $GLOBALS["INDEX_EXISTS"][$md5][$table][$indexz]=true;
                }

            }


        }

        $stable=strtolower($stable);
        $sindexname=strtolower($sindexname);

        if($GLOBALS["INDEX_EXISTS"][$md5][$stable][$sindexname]){return true;}


        return false;

    }

	
	public function FIELD_EXISTS($table,$field,$none=null){
		$field=trim(strtolower($field));
		
		if(!isset($GLOBALS["FIELD_EXISTS"][$table])){
			$sql="SELECT m.name as tableName, p.name as columnName FROM sqlite_master m 
			left outer join pragma_table_info((m.name)) p on m.name <> p.name WHERE m.name='$table' order by tableName, columnName";
			$results=$this->QUERY_SQL($sql);
			if(!$this->ok){return false;}
			if(count($results)==0){return false;}
			foreach ($results as $index=>$ligne){$GLOBALS["FIELD_EXISTS"][$table][strtolower($ligne["columnName"])]=true; }
		}
		if(!isset($GLOBALS["FIELD_EXISTS"][$table][$field])){return false;}
		return true;
	}
	
	public function TABLE_EXISTS($tablename){return $this->IF_TABLE_EXISTS($tablename);}

    public function IF_TABLE_EXISTS($tablename){
        if(!extension_loaded("pdo_sqlite")){return false;}
        $database=basename($this->db_path);
        if(isset($GLOBALS["TABLES_$database"][$tablename])){return true;}

           $sql="Select * FROM $tablename LIMIT 1";
            try {
                $db = new PDO("sqlite:$this->db_path");
                $db->setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
                $db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_SILENT);
            } catch (PDOException $e){
                $error=$e->getMessage();
                writelogs("[DB:$database]: $error",__FUNCTION__,__FILE__,__LINE__);
                return false;
            }

            try {
                $results = $db->query($sql);
            } catch (PDOException $e){
                $error=$e->getMessage();
                writelogs("[DB:$database]: $error",__FUNCTION__,__FILE__,__LINE__);
                return false;
            }
            $GLOBALS["TABLES_$database"][$tablename]=true;
            return $GLOBALS["TABLES_$database"][$tablename];

        }

	
	
	public function COUNT_ROWS($table){
		$sql="SELECT count(*) as tcount from `$table`";
		$results=$this->QUERY_SQL($sql);
		return $results[0]["tcount"];
		
	}
	
	public function BuildTables(){
		//for backward compatibilities.
	}
	
	
	public	function QUERY_SQL($sql){
		$chmod=false;
		$LASTID=false;
        $sql_log=$sql;
        if(strlen($sql_log)>512){
            $sql_log=substr($sql_log,0,512)."...";
        }
		if($this->db_path==null){$this->mysql_error="Line:". __LINE__." DB Path is null";return;}
		if(!extension_loaded("pdo_sqlite")){
			$this->ok=false;
			$this->mysql_error="pdo_sqlite module no loaded";
   		    return false;
		}
		
		if(preg_match("#insert\s+into\s+(.+?)\s+#i", $sql,$re)){
			$LASTID=true;
			$LASTID_table=$re[1];
			$LASTID_table=str_replace("`", "", $LASTID_table);
			$LASTID_table=str_replace("'", "", $LASTID_table);
			$LASTID_table=str_replace('"', "", $LASTID_table);
		}
		
		$this->sql=$sql;
		if(!is_file($this->db_path)){$chmod=true;}
		$this->ok=true;
		
		try {
			$db = new PDO("sqlite:$this->db_path");
			$db->setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
			$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_SILENT); //  | ERRMODE_EXCEPTION | ERRMODE_SILEN
			if($chmod){@chmod($this->db_path, 0777);}
		} catch (PDOException $e){
			
			$trace=@debug_backtrace();
			foreach ($trace as $index=>$trace){$zlines[]="File ".basename($trace["file"])." Function {$trace["function"]} Line:{$trace["line"]}";}
			$error=$e->getMessage();
			$this->ok=false;
			$this->mysql_error="Line:". __LINE__." ".$error ." in $this->db_path\n#<br>".@implode("\n#<br>", $zlines);
            $this->SQLITE_ERROR($e->getMessage(),debug_backtrace(),$sql_log);
			return false;
		}
		
		try {
			$results = $db->query($sql);
		} catch (PDOException $e){

			$trace=@debug_backtrace();
			foreach ($trace as $index=>$trace){$zlines[]="File ".basename($trace["file"])." Function {$trace["function"]} Line:{$trace["line"]}";}
			$error=$e->getMessage();
			$this->ok=false;
			$this->mysql_error="Line:". __LINE__." ".$error ." in $this->db_path\n#<br>".@implode("\n#<br>", $zlines);
			$db=null;
            $this->SQLITE_ERROR($e->getMessage(),debug_backtrace(),$sql_log);
			return false;
		}
		
		
		if ($results === false) {
			$trace=@debug_backtrace();
			if($GLOBALS["VERBOSE"]){echo "SQLITE ERROR[".__LINE__."] $this->db_path\n";}
			if($GLOBALS["VERBOSE"]){echo "SQLITE ERROR[".__LINE__."] $sql\n";}
			foreach ($trace as $index=>$trace){$zlines[]="File ".basename($trace["file"])." Function {$trace["function"]} Line:{$trace["line"]}";}
			$error = $db->errorInfo();
			$this->ok = false;

			foreach ($error as $index=>$text){$serror[]=$text;}
            if(preg_match("#(UNIQUE constraint failed|already exists)#i",@implode(" ", $serror))){
                return false;
            }

            writelogs("SQLITE Error: [0] $sql",__FUNCTION__,__FILE__,__LINE__);
            foreach ($error as $index=>$text){
                writelogs("SQLITE Error: $index] $text $this->db_path",
                    __FUNCTION__,__FILE__,__LINE__);
                if(is_numeric($text)){continue;}
                if($GLOBALS["VERBOSE"]){echo "SQLITE ERROR[".__LINE__."] $text\n";}
            }


			$this->mysql_error = "<br>\n#SQL.".__LINE__." ".
                @implode("\n#<br>", $serror)."\n#in in $this->db_path\n#<br>".
                @implode("\n#<br>", $zlines);




			$this->SQLITE_ERROR($db->errorInfo(),debug_backtrace(),$sql_log);
			return false;
		}
		
		if(preg_match("#^DELETE\s+#i", $sql)){return true;}
		
		$FINAL=$results->fetchAll(PDO::FETCH_ASSOC);
		$db=null;
		if($LASTID){$this->get_last_id($LASTID_table);}
		return $FINAL;
		
		
		
}

private function SQLITE_ERROR($error,$debug,$sql){
	    writelogs("SQLITE_ERROR $sql",__FUNCTION__,__FILE__,__LINE__);
	    if(preg_match("#(INSERT|CREATE).*?sql_errors#i",$sql)){return false;}

	    $subject="SQLite Error";
    $database_path=$this->db_path;
    if(!is_array($error)){
        $subject=str_replace("'","`",$error);
        $error=base64_encode($error);
    }else {
        $error = base64_encode(serialize($error));
    }
    $debug=base64_encode(serialize($debug));
    $sqlsrc=base64_encode($sql);

    $zdate=time();
    $sql="INSERT INTO sql_errors (zdate,subject,error,sql,database,debug) VALUES('$zdate','$subject','$error','$sqlsrc','$database_path','$debug')";

    if(!is_dir("/usr/share/artica-postfix/ressources/logs/sql_errors")){
        $sock=new sockets();
        $sock->getFrameWork("artica.php?install-sql-errors=yes");
    }
    $md=md5($sql);
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/sql_errors/$md",$sql);
}

	private function get_last_id($table_name){
		$ligne=$this->mysqli_fetch_array("select seq from sqlite_sequence where name=\"$table_name\"");
		$this->last_id=$ligne["seq"];
	}


	public function mysqli_fetch_array($sql){
		$results=$this->QUERY_SQL($sql);
		if(!isset($results[0])){
			if(!$this->ok){VERBOSE($sql." Return none", __LINE__);VERBOSE($this->mysql_error, __LINE__);}
			return null;
		}
		return $results[0];
		
	}
	public function sqlite_escape_string2($line){
		$line=str_replace("'", "''", $line);
		return $line;
	}

public function mysql_error_html($asnew=false,$sql=null){
	$asnew=true;
	if($sql<>null){$sql="<br><strong>$sql</strong>";}
	if($this->sql<>null){$this->sql="<br>$this->sql";$this->sql=str_replace("\n", "<br>", $this->sql);}
	$trace=@debug_backtrace();
	if(isset($trace[1])){
		$called="in ". basename($trace[1]["file"])." function {$trace[1]["function"]}() line {$trace[1]["line"]}";
	}

	if($asnew){
		return "<div class='alert alert-danger'>$this->mysql_error$this->sql$sql<br><i>$called</i></div>";
			
	}

	return "<p class=text-error>$this->mysql_error$this->sql$sql<br><i>$called</i></p>";

}
	
	
	
}