<?php
	if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}
	if(!isset($GLOBALS["CLASS_USERS"])){$GLOBALS["CLASS_USERS"]=new settings_inc();}
	if(!isset($GLOBALS["CLASS_SOCKETS"])){$GLOBALS["CLASS_SOCKETS"]=new sockets();}

	
function SLAPD_VERSION(){
	$CACHE_FILE="/etc/artica-postfix/SLAPD_VERSION";
	if(isset($GLOBALS["SLAPD_VERSION"])){return $GLOBALS["SLAPD_VERSION"];}
	
	if(is_file($CACHE_FILE)){
		$CACHE_TIME=$GLOBALS["CLASS_UNIX"]->file_time_min($CACHE_FILE);
		if($CACHE_TIME>2880){
			$GLOBALS["SLAPD_VERSION"]= @file_get_contents($CACHE_FILE);
			return $GLOBALS["SLAPD_VERSION"];
		}
	}
	
	$bin_path=$GLOBALS["CLASS_UNIX"]->LOCATE_SLPAD_PATH();
	exec("$bin_path -VVV 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#openldap-([0-9\.]+)#", $line,$re)){
			$GLOBALS["SLAPD_VERSION"]=$re[1];
			if(is_file($CACHE_FILE)){@unlink($CACHE_FILE);}
			@file_put_contents($CACHE_FILE, $GLOBALS["SLAPD_VERSION"]);
			return $GLOBALS["SLAPD_VERSION"];
		}
		
	}
	
}	
	
	
function openldap(){

    if(intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("openldap_installed"))==0){return false;}
    $execNice="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]}";
    $Rexec="$execNice {$GLOBALS["PHP5"]} /usr/share/artica-postfix";

    $pid_path="/var/run/slapd/slapd.pid";

    $master_pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pid_path);


	$bin_path=$GLOBALS["CLASS_UNIX"]->LOCATE_SLPAD_PATH();
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableOpenLDAP")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableOpenLDAP", 1);
	}
	if(!is_file("/etc/artica-postfix/settings/Daemons/RestartOpenLDAP")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RestartOpenLDAP", 1);
	}	
	
	$EnableOpenLDAP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableOpenLDAP"));
	$RestartOpenLDAP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RestartOpenLDAP"));

	if($GLOBALS["VERBOSE"]){
		echo "pid_path = $pid_path\n";
		echo "master_pid = $master_pid\n";
		echo "bin_path = $bin_path\n";
	}


	$SLAPD_VERSION=SLAPD_VERSION();
	
	$squidbin=$GLOBALS["CLASS_UNIX"]->LOCATE_SQUID_BIN();
	$SquidPerformance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidPerformance"));
	$EnableIntelCeleron=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableIntelCeleron"));

	$l[]="[LDAP]";
	$l[]="service_name=APP_LDAP";
	$l[]="master_version=$SLAPD_VERSION";
	$l[]="service_cmd=/etc/init.d/slapd";
	$l[]="pid_path=$pid_path";
	$l[]="watchdog_features=1";
	$l[]="family=system";
	$l[]="bin_path=$bin_path";

	if(is_file($squidbin)){
		if($SquidPerformance>2){
			openldap_disable_cron();
			$l[]="service_disabled=0";
			return @implode("\n", $l);
		}
		if($EnableIntelCeleron==1){
			openldap_disable_cron();
			$l[]="service_disabled=0";
			return @implode("\n", $l);
		}
	}

	if($EnableOpenLDAP==0){
		openldap_disable_cron();
		$l[]="service_disabled=0";
		return @implode("\n", $l);
	}
	
	if($RestartOpenLDAP==1){openldap_enable_cron();}
	if($RestartOpenLDAP==0){openldap_disable_cron();}
	
	$size=@filesize("/etc/init.d/slapd");
	if($size==0){
		squid_admin_mysql(0, "Fatal: /etc/init.d/slapd 0 Bytes len [action=reinstall]",null,__FILE__,__LINE__);
		shell_exec2("$Rexec/exec.initslapd.php --enable-ldap >/dev/null 2>&1 &");
		return;
	}
	

	$l[]="service_disabled=1";
	$l[]="pid_path=$pid_path";
	$l[]="watchdog_features=1";
	$l[]="family=system";
	$l[]="bin_path=$bin_path";

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
	    $LOG[]="First Pid: $master_pid";

		$master_pid=intval($GLOBALS["CLASS_UNIX"]->PIDOF($bin_path));
        $LOG[]="pidof ($bin_path): $bin_path";

        if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
            $LOG[]="$master_pid: OK running";
			@file_put_contents($pid_path,$master_pid);
		}
	}


	$CACHE_TIME=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/local_ldap.php");
	if($CACHE_TIME>60){
		$ARRAY=$GLOBALS["CLASS_UNIX"]->ldap_GET_CONFS();
		@file_put_contents("/usr/share/artica-postfix/ressources/local_ldap.php", "<?php \$GLOBALS[\"MAIN_LOCAL_LDAP_SETTINGS\"]=\"".base64_encode(serialize($ARRAY))."\";?>");
		@chmod("/usr/share/artica-postfix/ressources/local_ldap.php",0755);
	}


	

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)) {
        $pid=$GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("exec.initslapd.php --restart");
        if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){ return; }

        $LastTime = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LDAP_WATCHDOG_STATUS"));
        $Rest = time() - $LastTime;

        if ($Rest > 300) {
            if ($GLOBALS["CLASS_UNIX"]->ServerRunSince() > 3) {
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LDAP_WATCHDOG_STATUS", time());
                $LOG[] = "ps...............:";
                exec("ps -aux|grep slap 2>&1", $LOG);

                foreach ($LOG as $line){
                    if(preg_match("#\/slapd (stop|start)#",$line)){
                        return true;
                    }
                }
                squid_admin_mysql(0,
                    "Fatal: Local LDAP service is not running [action=start]",
                    @implode("\n", $LOG),
                    __FILE__, __LINE__);
            }
            shell_exec2("$execNice /etc/init.d/slapd start --framework=" . basename(__FILE__) . " >/dev/null 2>&1 &");
            $l[] = "";
            return implode("\n", $l);
        }
    }


	if(!$GLOBALS["CLASS_UNIX"]->is_socket("/var/run/slapd/slapd.sock")){
		if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){squid_admin_mysql(0, "Fatal: No such  Unix socket /var/run/slapd/slapd.sock for LDAP service [action=restart]",null,__FILE__,__LINE__,"system");}
		shell_exec2("$execNice /etc/init.d/slapd restart --framework=". basename(__FILE__)." >/dev/null 2>&1 &");
	}



	if($RestartOpenLDAP==0){
		$RestartLDAPEach=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RestartLDAPEach"));
		if(!is_numeric($RestartLDAPEach)){$RestartLDAPEach=4320;}
		if($RestartLDAPEach>0){
			$ProcessTime=$GLOBALS["CLASS_UNIX"]->PROCCESS_TIME_MIN($master_pid);
			if($ProcessTime>$RestartLDAPEach){
				squid_admin_mysql(2, "Local LDAP service TTL {$ProcessTime}mn exceed {$RestartLDAPEach}mn [action=restart]",
                    __FUNCTION__,__FILE__,__LINE__,"system");
				shell_exec2("$execNice /etc/init.d/slapd restart --framework=". basename(__FILE__)." >/dev/null 2>&1 &");
			}
		}
	}



	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";

	return implode("\n",$l);return;

}
//========================================================================================================================================================
function openldap_disable_cron(){
	if(!is_file("/etc/cron.d/openldap-restart")){return;}
	@unlink("/etc/cron.d/openldap-restart");
	shell_exec("/etc/init.d/cron reload");
}

function openldap_enable_cron(){
	if(is_file("/etc/cron.d/openldap-restart")){return;}
	Popuplate_cron_make("openldap-restart","30 6,12,3 * * *","exec.initslapd.php --restart --force --framework=cron-daemon");
	shell_exec("/etc/init.d/cron reload");
}

